-- 战令
checkRequire("Lua_InternalActivitiesWindow");
Lua_WarOrderWindow = class("Lua_WarOrderWindow", Lua_InternalActivitiesWindow);
function Lua_WarOrderWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_WarOrderWindow";
	self.isFullPaving = true;
	self.mainItemW = 120;
	self.mainItemH = 118;

	self.iconId = Lua_MenuViewDefine.ICON_WAR_ORDER;
	if DataCenter.backstageActData:checkBackstageActivities(self.windowName, self.iconId) then
		self.haveBackstageActivities = true;
		self:addPreLoadRes("backstage_activities_lua", Lua_LoadFileType.LUA);
	end
end

function Lua_WarOrderWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.backBtn:setAltas("common_altas_1", "xui_common_button_026");
	self.backBtn:resetSize();
	self.backBtn:setLocation(58, 54);

	self.actList:setListCell(Lua_WarOrderMainItem, self.mainItemW, self.mainItemH, 1);
	self.actList:setLocation(360, 53, 0);

	self.btnListBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_widget_002", 0, 60.5, 720, 121);
	self.btnListBg.anchor = Lua_WindowUtil.getAnchor(7);
	self.btnListBg.siblingIndex = 1;
end

function Lua_WarOrderWindow:setShowActList(arr, selectIdx, actVo)
	if self.isFirstIn ~= true then
		self.isFirstIn = true;
		-- 通过按钮打开正常是1，那个有红点选择那个即不考虑首次登录红点之后消失的情况
		if self.showData == nil or self.showData == 1 then
			local redDotState;
			for i = 1, arr:getSize() do
				redDotState = DataCenter.redPointData:getRedPointStateById(arr[i].redPointId);
				if redDotState then
					if arr[i].actIdx == nil then
						selectIdx = self:getSelectIdx(arr, arr[i].id);
					else
						selectIdx = self:getSelectIdx(arr, arr[i].actIdx);
					end
					break;
				end
			end
		end
	end

	selectIdx = selectIdx or 1;
	local width = self.mainItemW * arr:getSize();
	width = width > 605 and 605 or width;
	self.actList:setContentRect(width, self.mainItemH, false);
	self.actList:setArrayData(arr);
	self.actList.canDrag = not self.actList.isTheEnd
	self.actList:moveToIndex(selectIdx, true);
	self.actList:setSelectClick(selectIdx);
end

function Lua_WarOrderWindow:dispose()
	if self.btnListBg ~= nil then
		self.btnListBg:dispose();
		self.btnListBg = nil;
	end
	self:superCall("dispose");
end









Lua_WarOrderMainItem = class("Lua_WarOrderMainItem", Lua_ActivityMainItem);
function Lua_WarOrderMainItem:ctor(p)
	self:superCall("ctor", p, "WarOrderMainItem_skin");
end

function Lua_WarOrderMainItem:onSelectionChange(bSelect)
	self:superCall("onSelectionChange", bSelect);
	self.selectBg:setEnable(bSelect);
end

function Lua_WarOrderMainItem:checkRedPoint()
	self:superCall("checkRedPoint");
	if self.redPoint ~= nil then
		self.redPoint:setLocation(40, 40);
	end
end