-- 积天豪礼
Lua_CumulateGiftPanel = class("Lua_CumulateGiftPanel", Lua_DisplayObject);
function Lua_CumulateGiftPanel:ctor(p)
	self:superCall("ctor", p, "CumulateGiftPanel_skin");
end

function Lua_CumulateGiftPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.rechargeTxt_1:setLangValue(203500);
	self.rechargeTxt_3:setLangValue(203501);
	self.rechargeTxt_1:resetSize();

	self.giftList = Lua_DragList.new(self.content, 672, 650  + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.giftList.tweenId = 2002;
	self.giftList:setListCell(Lua_CumulateGiftItem, 672, 183, 1);
	self.giftList:setCellSpacing(0, 3);
	self.giftList:setLocation(0, -25, 0);

	self.showList = Lua_DragList.new(self.content, 299, 93, Lua_AxisDefine.Horizontal);
	self.showList:setListCell(Lua_CumulateGiftSubItem, 93, 93, 1);
	self.showList:setCellSpacing(10, 0);
	self.showList:setRectPivot(3);
	self.showList:setRectAnchor(7);
	self.showList:setLocation(-189, 270, 0);

	self.ruleBtn:addClickFuntion(self, self.onRuleClick);
	self.stateBtn:addClickFuntion(self, self.onBtnClick);

	self:addLuaEvent("UPDATE_CUMULATE_GIFT_INFO", self, self.updateCumulateGiftInfo);
	Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sCumulateGiftInfo(1);
end

function Lua_CumulateGiftPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	self.giftList:setContentRect(672, 650 + adaptHeight);
end

function Lua_CumulateGiftPanel:setData(data)
end

function Lua_CumulateGiftPanel:updateCumulateGiftInfo()
	local cumulateGiftData = DataCenter.cumulateGiftData;
	self.giftList:setArrayData(cumulateGiftData.cumulateGiftArr);

	local info = cumulateGiftData:getCumulateGiftVo(cumulateGiftData.index);
	if info == nil then
		return;
	end
	self.rechargeTxt_2.text = info.targetMoney;
	self.rechargeTxt_2:resetSize();
	self.rechargeTxt_2:setLocation(self.rechargeTxt_1.posX + self.rechargeTxt_1.width, -111, 0);
	self.rechargeTxt_3:setLocation(self.rechargeTxt_2.posX + self.rechargeTxt_2.width + 1, -112, 0);
	
	local alreadyRecharge = info.drawState >= 1 and cumulateGiftData.rechargeDays or cumulateGiftData.rechargeDays - 1;
	self.alreadyRechargeTxt.text = LanUtil.formateStr(203502, alreadyRecharge, cumulateGiftData.constConfig.show_days);

	local showGiftId = cumulateGiftData.showGiftId;
	local rewardInfo = cumulateGiftData:getCumulateGiftVo(showGiftId);
	if showGiftId == nil or rewardInfo == nil then
		self.stateBtn:setEnable(false);
		self.tipsIcon:setEnable(false);
		return;
	end
	local showInfo = getConfig("cumulate_days_recharge", showGiftId, cumulateGiftData.rewardKey);
	self.showList.canDrag = #showInfo > 3;
	self.showList:setArrayData(showInfo);

	if rewardInfo.drawState == 0 then
		self.stateBtn:setStyle(16);
		self.stateBtn:setLangValue(203505); -- 前往充值
	elseif rewardInfo.drawState == 1 then
		local langId = rewardInfo.targetMoney > 0 and 203506 or 203508;
		self.stateBtn:setStyle(1);
		self.stateBtn:setLangValue(langId); -- 领取
	else
		self.tipsIcon:setAltas("common_altas_1", "xui_common_label_12");
	end
	self.stateBtn:setEnable(rewardInfo.drawState ~= 2);
	self.tipsIcon:setEnable(rewardInfo.drawState == 2);
	self:showRedDot(rewardInfo.drawState == 1);
end

function Lua_CumulateGiftPanel:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setRectAnchor(7);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
		self.redPoint:setLocation(315, 288, 0);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_CumulateGiftPanel:onRuleClick(go)
	local tipsData = { des = LanUtil.getValue(203509), posX = 175, posY = -260 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_CumulateGiftPanel:onBtnClick(go)
	local rewardInfo = DataCenter.cumulateGiftData:getCumulateGiftVo(DataCenter.cumulateGiftData.showGiftId);
	if rewardInfo.drawState == 0 then
		DataCenter.funcPathUtil:gotoFunction(1024)
	elseif rewardInfo.drawState == 1 then
		Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sReceiveCumulateGiftGift(rewardInfo.id);
	end
end

function Lua_CumulateGiftPanel:dispose()
	if self.giftList ~= nil then
		self.giftList:dispose();
		self.giftList = nil;
	end
	if self.showList ~= nil then
		self.showList:dispose();
		self.showList = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self:superCall("dispose");
end










Lua_CumulateGiftItem = class("Lua_CumulateGiftItem", Lua_ListCell);
function Lua_CumulateGiftItem:ctor(p)
    self:superCall("ctor", p, "CumulateGiftItem_skin");
end

function Lua_CumulateGiftItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 400, 93, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_CumulateGiftSubItem, 93, 93, 1);
	self.rewardList:setCellSpacing(10, 0);
	self.rewardList:setRectPivot(3);
	self.rewardList:setLocation(-302, -12, 0);
	self:setSubList(self.rewardList);

	self.stateBtn:addClickFuntion(self, self.onBtnClick);
end

function Lua_CumulateGiftItem:setData(data)
	self._data = DataCenter.cumulateGiftData:getCumulateGiftVo(data);
	if data == nil or self._data == nil then
		return;
	end

	if self._data.targetMoney > 0 then
		self.titleTxt.text = LanUtil.formateStr(203504, self._data.grade);
		self.stateBtn:setLocation(240, 4, 0);
	else
		self.titleTxt:setLangValue(203507);
		self.stateBtn:setLocation(240, -16, 0);
	end

	local rewardKey = DataCenter.cumulateGiftData.rewardKey;
	local rewardInfo = getConfig("cumulate_days_recharge", self._data.id, rewardKey);
	self.rewardList.canDrag = #rewardInfo > 4;
	self.rewardList:setArrayData(rewardInfo);

	local value = self._data.drawState == 1 and self._data.targetMoney or self._data.rechargeMoney;
	if self._data.id == DataCenter.cumulateGiftData.index then
		value = self._data.rechargeMoney;
	else
		value = self._data.drawState == 1 and self._data.targetMoney or self._data.rechargeMoney;
	end
	self.progressBar:setMaxValue(self._data.targetMoney);
	self.progressBar:setValue(value);
	self.progressBar:setText(value .."/".. self._data.targetMoney);

	local isBtnShow = false;
	local isBarShow = false;
	local isTisShow = false;
	local index = DataCenter.cumulateGiftData.index;
	if self._data.drawState == 0 then
		if self._data.id == index then
			isBtnShow = true;
			isBarShow = true;
			self.stateBtn:setStyle(16);
			self.stateBtn:setLangValue(203505); -- 前往充值
		else
			isTisShow = true;
			self.tipsIcon:setAltas("activities_atlas_2", "xui_jthl_label_12");
		end
	elseif self._data.drawState == 1 then
		isBtnShow = true;
		isBarShow = true;
		local langId = self._data.targetMoney > 0 and 203506 or 203508;
		self.stateBtn:setStyle(1);
		self.stateBtn:setLangValue(langId); -- 领取
	else
		isTisShow = true;
		self.tipsIcon:setAltas("common_altas_1", "xui_common_label_12");
	end
	self.stateBtn:setEnable(isBtnShow);
	self.progressBar:setEnable(isBarShow and self._data.targetMoney > 0);
	self.tipsIcon:setEnable(isTisShow);
	self:showRedDot(self._data.drawState == 1);
end

function Lua_CumulateGiftItem:showRedDot(bShow)
	if bShow == true then
		local posY = self._data.targetMoney > 0 and 21 or 1;
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
		self.redPoint:setLocation(303, posY, 0);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_CumulateGiftItem:onBtnClick(go)
	if self._data.drawState == 0 then
		if self._data.id == DataCenter.cumulateGiftData.index then
			DataCenter.funcPathUtil:gotoFunction(1024)
		end
	elseif self._data.drawState == 1 then
		Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sReceiveCumulateGiftGift(self._data.id);
	end
end

function Lua_CumulateGiftItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end










Lua_CumulateGiftSubItem = class("Lua_CumulateGiftSubItem", Lua_ItemIconCell);
function Lua_CumulateGiftSubItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.75, 0.75);
end