-- 英雄皮肤商店
checkRequire("Lua_HeroSkinShopSubItem")
Lua_HeroSkinShopPanel = class("Lua_HeroSkinShopPanel", Lua_DisplayObject);
function Lua_HeroSkinShopPanel:ctor(p)
	self:superCall("ctor", p, "HeroSkinShopPanel_skin");
end

function Lua_HeroSkinShopPanel:buildShowItem()
	self:superCall("buildShowItem");

	self:initShopData();
	self.itemList = Lua_DragList.new(self.content, 700, self.listHeight + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.itemList:setListCell(Lua_HeroSkinShopItem, 236, 370, 3);
	self.itemList:setRectPivot(1);
	self.itemList:setRectAnchor(1);
	self.itemList:setCellSpacing(0, 16);
	self.itemList:setLocation(-3, self.listPosY, 0);
	self.itemList.tweenId = 2013;

	self.rewardList = Lua_DragList.new(self.publicizeObj, 324 + self.adaptHeight, 92, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_HeroSkinShopRewardItem, 92, 92, 1);
	self.rewardList:setRectPivot(0);
	self.rewardList:setRectAnchor(1);
	self.rewardList:setCellSpacing(0, 16);
	self.rewardList:setLocation(-307, 260, 0);

	local shopData = DataCenter.shopUtil:getShopItemInfo(Lua_ShopData.HERO_SKIN_SHOP, self.themeId);
	if shopData ~= nil then
		self.rewardList:setArrayData(shopData.additional_rewards)
	end

	self.receiveSp:addClickFuntion(self, self.onCLickReceiveSp);
	self:addLuaEvent("UPDATE_SHOP_INFO", self, self.updateThemeSkinShop);
	self:updateThemeSkinShop();
end

function Lua_HeroSkinShopPanel:initShopData()
	local shopTypeData = DataCenter.shopUtil:getShopTypeVo(Lua_ShopData.HERO_SKIN_SHOP);
	if shopTypeData == nil then
		return;
	end

	self.propDescTxt_1:setLangValue(172006);
	self.propDescTxt_2:setLangValue(172007);
	self.themeId = shopTypeData.theme_id;
	if self.themeId ~= nil then
		local shopData = DataCenter.shopUtil:getShopItemInfo(Lua_ShopData.HERO_SKIN_SHOP, self.themeId);
		if shopData ~= nil then
			local cfg = getConfig("hero_clothes", shopData.clothes_id);
			if cfg == nil then
				return;
			end

			local bClassic = cfg.skin_type == 1;--getConfig("hero_clothes", shopData.clothes_id, "skin_type") == 1;
			self.classicSp:setEnable(bClassic);

			self.propTxt_1.text = self:getPropDesc(cfg.prop);
			self.propTxt_2.text = self:getPropDesc(cfg.all_hero_prop);
		end
	end

	local bShow = shopTypeData.show_publicize == 1;
	if bShow then
		self.listHeight = 650;
		self.listPosY = -612;
	else
		self.listHeight = 1043
		self.listPosY = -219;
	end
	self.publicizeObj:SetActive(bShow);
	self.pathId = shopTypeData.func_path;

	local linkActData = shopTypeData.activity_id;
	if linkActData ~= nil then
		local type = linkActData[1];
		if type == 1 then
			self.bLinkActOpen = DataCenter.internalActData:checkActIsOpened(linkActData[2]);
		else
			local actVo = DataCenter.backstageActData:getActVoByIdx(linkActData[2]);
			if actVo ~= nil and actVo.bOpened then
				self.bLinkActOpen = true;
			else
				self.bLinkActOpen = false;
			end
		end
	end
end

function Lua_HeroSkinShopPanel:getPropDesc(props)
	if props == nil then
		return;
	end

	local desc = "";
	local propList = {};
	for k, v in pairs(props) do
		propList[#propList + 1] = { propKey = k, propValue = v};
	end

	table.sort( propList, function(a, b) 
			local aSort = getConfig("tb_prop", a.propKey, "sort") or 1;
			local bSort = getConfig("tb_prop", b.propKey, "sort") or 1;
			return aSort < bSort;
		end
		);

	local attVo;
	for i = 1, #propList do
		attVo = Lua_AttributesVo.new(propList[i].propKey);
		attVo.value = propList[i].propValue;
		desc = desc.. LanUtil.formateStr(172009, 
			attVo.show_name or "",
			attVo.showValue or "");
	end

	return desc;
end

function Lua_HeroSkinShopPanel:onScreenResize(adaptHeight)
	if self.adaptHeight ~= adaptHeight then
		self:superCall("onScreenResize", adaptHeight);

		self.itemList:setContentRect(700, self.listHeight + adaptHeight);
	end
end

function Lua_HeroSkinShopPanel:setData(data)
end

function Lua_HeroSkinShopPanel:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end

function Lua_HeroSkinShopPanel:updateThemeSkinShop()
	local list = DataCenter.shopData:getCurShopItemList(Lua_ShopData.HERO_SKIN_SHOP);
	self.itemList:setArrayData(list);
end

function Lua_HeroSkinShopPanel:onCLickReceiveSp()
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	if self.bLinkActOpen then
		DataCenter.funcPathUtil:gotoFunction(self.pathId);
	else

	end
end

















Lua_HeroSkinShopItem = class("Lua_HeroSkinShopItem", Lua_ListCell);
function Lua_HeroSkinShopItem:ctor(p)
	self:superCall("ctor", p, "HeroSkinShopItem_skin");
end

function Lua_HeroSkinShopItem:buildShowItem()
	self:superCall("buildShowItem");

	self.subItem = Lua_HeroSkinShopSubItem.new(self.content);
	self.subItem:setLocation(-2, 24);

	self.costBg:addClickFuntion(self, self.onClickCostBg);
end

function Lua_HeroSkinShopItem:dispose()
	self.data = nil;
	if self.subItem ~= nil then
		self.subItem:dispose();
		self.subItem = nil;
	end
	self:superCall("dispose");
end

function Lua_HeroSkinShopItem:setData(data)
	self.data = data;

	if data == nil then
		return;
	end

	self.subItem:setData(data);

	-- 敬请期待
	if self:showPreViewDisplay() then
		return;
	end

	local hasSkin = data.isSoldOut;
	if hasSkin then
		self.hasTxt:setLangValue(172000);
	else
		local priceStr;
		local atlas, sprite;
		local buyType = data.buyType;
		local txtPosX;
		if buyType == 1 then
			local moneyNum = self:getRechargeNum(data.recharge_id) or 1;
			priceStr = LanUtil.formateStr(172001, moneyNum);
			txtPosX = 0;
		else
			if buyType == 2 then
				priceStr = data.moneyCount;
			elseif buyType == 3 then
				local moneyNum = self:getRechargeNum(data.recharge_id) or 1;
				priceStr = LanUtil.formateStr(172002, data.moneyCount, moneyNum);
			end
			tvo = Lua_ToolVo.createToolVo(data.moneyType);
			atlas, sprite = tvo.atlas, tvo.sprite;
			txtPosX = 23;
		end

		self.costSp:setEnable(buyType ~= 1)
		self.costSp:setAltas(atlas, sprite);
		self.costTxt:setLocation(txtPosX, -181);
		self.costTxt.text = priceStr;
		self.costTxt:resetSize();
		local posX = -27 - self.costTxt.preferredWidth / 2;
		self.costSp:setLocation(posX, -181);
	end
	self.hasObj:SetActive(hasSkin);
	self.costObj:SetActive(not hasSkin);
end

function Lua_HeroSkinShopItem:onClickCostBg(go)
	if self.data == nil then
		return;
	end

	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	local hasSkinItem = DataCenter.packData:getItemCountById(self.data.itemId) > 0;
	if hasSkinItem then
		local tvo = Lua_ToolVo.createToolVo(self.data.itemId);
		local tipsData = { 
			titleAtlas = "shop_atlas_1", 
			titleSprite = "ui_gmqr_title_02", 	
			-- font_size = self.showData.font_size;
			des = LanUtil.formateStr(172011, tvo.colorName), 
			btnType = 1, 
			owner = self, 
			sureFun = self.openShopWin };
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_AUTO, tipsData);
	else
		self:openShopWin();
	end
end

function Lua_HeroSkinShopItem:openShopWin()
	Lua_WindowUtil.openWin("Lua_HeroSkinShopWindow", Lua_WinParam.ACTION_OPEN, self.data);
end

function Lua_HeroSkinShopItem:getRechargeNum(recharge_id)
	local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(recharge_id);
	if rechargeInfo ~= nil then
		return rechargeInfo.money;
	end
end

function Lua_HeroSkinShopItem:onPressClick()
	if self.data == nil or self.bPreView then
		return;
	end

	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	if self.subItem:checkInBound(winPos.x, winPos.y) then
		local skinId = self.data.clothes_id;
		local heroId = getConfig("hero_clothes", skinId, "hero_id");
		DataCenter.heroAtlasData:onOpenAtlasWindow(heroId, 4, true, nil, true, nil, skinId);
		return;
	end
end

-- 敬请期待
function Lua_HeroSkinShopItem:showPreViewDisplay()
	self.bPreView = self.data.make_type == 1;
	if self.bPreView then
		self.costObj:SetActive(false);
		self.hasObj:SetActive(false);
	end

	return self.bPreView;
end









Lua_HeroSkinShopRewardItem = class("Lua_HeroSkinShopRewardItem", Lua_ItemIconCell)
function Lua_HeroSkinShopRewardItem:buildShowItem()
	self:superCall("buildShowItem")

	self.itemIcon:setScale(0.74, 0.74, 1)
end