-- 皮肤商店item
Lua_HeroSkinShopSubItem = class("Lua_HeroSkinShopSubItem", Lua_DisplayObject);
function Lua_HeroSkinShopSubItem:ctor(p)
	self:superCall("ctor", p, "HeroSkinShopSubItem_skin");
end

function Lua_HeroSkinShopSubItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemW = 214;
	self.itemH = 298;
	self:setRectSize(self.itemW, self.itemH)
end

function Lua_HeroSkinShopSubItem:dispose()
	self.data = nil;
	if self.scrollText ~= nil then
		self.scrollText:dispose();
		self.scrollText = nil;
	end
	self:superCall("dispose");
end

function Lua_HeroSkinShopSubItem:setData(data)
	self.data = data;

	if data == nil then
		return;
	end

	if self:showPreViewDisplay() then
		return;
	end

	local skinId = self.data.clothes_id;
	local cfg = getConfig("hero_clothes", skinId);
	if cfg == nil then
		return;
	end
	local path = cfg.skin_pic;
	if path ~= nil then
		path = "/images/hero_fashion/"..path;
	else
		path = nil;
	end
	self.heroBg:setUrl(path);

	local bClassic = cfg.skin_type == 1;
	local decorateUrl = bClassic and "/images/activities/xui_pfsd_widget_1.png" or "/images/activities/xui_pfsd_widget_5.png";
	self.decoBg:setUrl(decorateUrl);
	self.classicSp:setEnable(bClassic);
	
	local str;
	local residueTime = 0;
	if residueTime > 0 then
		-- str = "剩余天数"; -- 有这玩意？预留
	end
	self.residueBg:setEnable(residueTime > 0);
	self.residueTxt.text = str;

	self:setTxtDisplay(data.name);
end

function Lua_HeroSkinShopSubItem:setTxtDisplay(str)
	self.itemNameTxt.text = str;
	self.itemNameTxt:resetSize();
    if self.itemNameTxt.width > 210 then
        self.itemNameTxt:setEnable(false);
        if self.scrollText == nil then
            self.scrollText = Lua_ScrollText.new(self.content, Lua_AxisDefine.Horizontal, 210, 46);
            self.scrollText:setLocation(0, -116, 0);
            self.scrollText:setTextStyle(210, 46, Lua_MyUISettings.huakangFontName, 22, "FFFFFF", 0, nil);
        end
        self.scrollText:setEnable(true);
        self.scrollText:setShowTxt(str);
    else
        self.itemNameTxt:setEnable(true);
        if self.scrollText then
            self.scrollText:setEnable(false);
        end
    end
end

function Lua_HeroSkinShopSubItem:checkInBound(touchX, touchY)
	local posX = self.posX or 0
	local posY = self.posY or 0
	local scaleX = self.scaleX or 1
	local scaleY = self.scaleY or 1
	local minX = posX - self.itemW / 2 * scaleX
	local maxX = posX + self.itemW / 2 * scaleX
	local minY = posY - self.itemH / 2 * scaleY
	local maxY = posY + self.itemH / 2 * scaleY
	if touchX >= minX and touchX <= maxX and touchY >= minY and touchY <= maxY then
		return true
	end
	return false
end


-- 敬请期待
function Lua_HeroSkinShopSubItem:showPreViewDisplay()
	local bPreView = self.data.make_type == 1;
	if bPreView then
		local bClassic = false;
		local decorateUrl = bClassic and "/images/activities/xui_pfsd_widget_1.png" or "/images/activities/xui_pfsd_widget_5.png";
		self.decoBg:setUrl(decorateUrl);
		self.classicSp:setEnable(bClassic);
		self.heroBg:setUrl("/images/activities/xui_pfsd_preview.png");
		self.residueBg:setEnable(false);
		self.residueTxt.text = nil;
		self:setTxtDisplay(LanUtil.getValue(172010));
	end

	return bPreView;
end