-- 皮肤商店购买窗口
checkRequire("Lua_HeroSkinShopSubItem")
Lua_HeroSkinShopWindow = class("Lua_HeroSkinShopWindow", Lua_Window);
function Lua_HeroSkinShopWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.windowName = "Lua_HeroSkinShopWindow";
	self.skinName = "HeroSkinShopWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_HeroSkinShopWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.subItem = Lua_HeroSkinShopSubItem.new(self.content);
	self.subItem:setLocation(-203, 36);

	self.shopBtn1:addClickFuntion(self, self.onClickShopBtn);
	self.shopBtn2:addClickFuntion(self, self.onClickRechargeBtn);
end

function Lua_HeroSkinShopWindow:showWin(param) 
	self:superCall("showWin", param);

	self.subItem:setData(param)

	local buyType = param.buyType;
	self.recharge_id = param.recharge_id;
	self.costId = param.moneyType;
	self.costCount = param.moneyCount;
	if buyType == 1 then
		local moneyNum = self:getRechargeNum(self.recharge_id);
		priceStr = LanUtil.formateStr(172001, moneyNum);
		self.shopBtn2:setLocation(0, -205);
		self.shopBtn2.label = priceStr;
	else
		local tvo = Lua_ToolVo.createToolVo(self.costId);
		local atlas, sprite = tvo.atlas, tvo.sprite;
		if buyType == 2 then
			self.shopBtn2:setEnable(false);
			LuaUtil.setObjPos(self.costObj, 166, 0, 0);
		elseif buyType == 3 then
			local moneyNum = self:getRechargeNum(self.recharge_id);
			priceStr = LanUtil.formateStr(172001, moneyNum);
			self.shopBtn2.label = priceStr;
		end
		local str;
		local hasCount = DataCenter.packData:getItemCountById(self.costId);
		if hasCount >= self.costCount then
			str = LanUtil.formateStr(172003, hasCount, self.costCount);
		else
			str = LanUtil.formateStr(172004, hasCount, self.costCount);
		end
		self.costSp:setAltas(atlas, sprite);
		self.costTxt.text = str;
		self.shopBtn1.label = self.costCount;
		self.shopBtn1.txt:resetSize();
		self.shopBtn1.txt:setLocation(23, 3)
		local posX = -167 - self.shopBtn1.txt.width / 2;
		self.costSp:setLocation(posX, -200); 
	end

	self.costObj:SetActive(buyType ~= 1);

	local skinId = param.clothes_id;
	local skin_desc = getConfig("hero_clothes", skinId, "skin_desc") or "";
	self.descTxt_3.text = LanUtil.formateStr(172005, skin_desc);

	self:updatePropItems();
end

function Lua_HeroSkinShopWindow:updatePropItems()
	local skinId = self.showData.clothes_id;
	local cfg = getConfig("hero_clothes", skinId);
	if cfg == nil then
		return;
	end

	if self.propItems == nil then
		self.propItems = {};
	end

	local item;
	local posX;
	local prop = self:sortPropCfg(cfg.prop);
	local propLen = #prop;
	for i = 1, #prop do
		item = self.propItems[i];
		if item == nil then
			item = Lua_HeroSkinShopPropItem.new(self.content);
			self.propItems[i] = item;
		end

		posX = 12 + (i - 1) * 207;
		item:setLocation(posX, 94);
		item:setData(prop[i]);
		item:setEnable(true);
	end
	self.descTxt_1:setLangValue(172006);

	prop = self:sortPropCfg(cfg.all_hero_prop);
	local allPropLen = #prop;
	for i = 1, #prop do
		item = self.propItems[i + propLen];
		if item == nil then
			item = Lua_HeroSkinShopPropItem.new(self.content);
			self.propItems[i + propLen] = item;
		end

		posX = 12 + (i - 1) * 207;
		item:setLocation(posX, 11);
		item:setData(prop[i]);
		item:setEnable(true);
	end
	self.descTxt_2:setLangValue(172007);

	local count = propLen + allPropLen;
	if count < #self.propItems then
		for i = count + 1, #self.propItems do
			item = self.propItems[i];
			if item ~= nil then
				item:setEnable(false);
			end
		end
	end
end

function Lua_HeroSkinShopWindow:sortPropCfg(props)
	local propList = {};
	if props == nil then
		return propList;
	end

	for k, v in pairs(props) do
		propList[#propList + 1] = { propKey = k, propValue = v};
	end

	table.sort( propList, function(a, b) 
			local aSort = getConfig("tb_prop", a.propKey, "sort") or 1;
			local bSort = getConfig("tb_prop", b.propKey, "sort") or 1;
			return aSort < bSort;
		end
		);

	return propList;
end

function Lua_HeroSkinShopWindow:dispose()
	if self.propItems ~= nil then
		for i = 1, #self.propItems do
			self.propItems[i]:dispose();
			self.propItems[i] = nil;
		end
		self.propItems = nil;
	end
	if self.subItem ~= nil then
		self.subItem:dispose();
		self.subItem = nil;
	end
	self:superCall("dispose");
end

function Lua_HeroSkinShopWindow:getRechargeNum(recharge_id)
	local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(recharge_id);
	if rechargeInfo ~= nil then
		return rechargeInfo.money;
	end
end

function Lua_HeroSkinShopWindow:onClickRechargeBtn()
	if self.recharge_id == nil then
		return;
	end

	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self.recharge_id);
	DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
		tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);

	self:hide();
end

function Lua_HeroSkinShopWindow:onClickShopBtn()
	if self.costId == nil or self.costCount == nil then
		return;
	end

	if self.clickTime ~= nil and getTime() - self.clickTime < 0.5 then
		return;
	end
	self.clickTime = getTime();

	local hasCount = DataCenter.packData:getItemCountById(self.costId);
	if hasCount < self.costCount then
		DataCenter.packUtil:openPathWindow(self.costId, false);
		self:hide();
	else
		-- print("Proto10113002", self.showData.id, self.showData.shopType, 1)
		Lua_ProxyManager.getProxy("Lua_ShopProxy"):sBuyShopItem(self.showData.id, self.showData.shopType, 1);
		self:hide();
	end
end









Lua_HeroSkinShopPropItem = class("Lua_HeroSkinShopPropItem", Lua_DisplayObject)
function Lua_HeroSkinShopPropItem:ctor(p)
	self:superCall("ctor", p, "HeroSkinShopPropItem_skin");
end

function Lua_HeroSkinShopPropItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_HeroSkinShopPropItem:dispose()
	self.data = nil;
	self:superCall("dispose");
end

function Lua_HeroSkinShopPropItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	local attVo = Lua_AttributesVo.new(data.propKey);
	attVo.value = data.propValue;
	self.propDescSp:setAltas("common_altas_2", attVo.attr_icon_2);
	self.propDescTxt.text = LanUtil.formateStr(172008, attVo.show_name, attVo.showValue);
end