-- 开服试炼-英雄挑战
Lua_HeroChallengePanel = class("Lua_HeroChallengePanel", Lua_DisplayObject);
function Lua_HeroChallengePanel:ctor(p)
	self:superCall("ctor", p, "HeroChallengePanel_skin");
end

function Lua_HeroChallengePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.rankArr = Array();

	self.rewardList = Lua_DragList.new(self.uitweenObj_1, 270, 75, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_HeroChallengeHeroInfoItem, 75, 75, 1);
	self.rewardList:setCellSpacing(2, 0);
	self.rewardList:setRectPivot(3);
	self.rewardList:setLocation(-140, 0, 0);

	self.curRankList = Lua_DragList.new(self.uitweenObj_3, 315, 75, Lua_AxisDefine.Horizontal);
	self.curRankList:setListCell(Lua_HeroChallengeCurRankRewardItem, 75, 75, 1);
	self.curRankList:setCellSpacing(5, 0);
	self.curRankList:setLocation(0, 236, 0);

	self.ruleBtn:addClickFuntion(self, self.onRuleClick);
	self.allRankBtn:addClickFuntion(self, self.onAllRankClick);
	self.taskBtn:addClickFuntion(self, self.onTaskClick);
	self.previewBtn:addClickFuntion(self, self.onPreviewClick);
	self.rewardBtn:addClickFuntion(self, self.onRewardClick);
	self.challengeBtn:addClickFuntion(self, self.onChallengeClick);

	self:addLuaEvent("UPDATE_HEROCHALLENGE_INFO", self, self.updateServerInfo);
	self:addLuaEvent("UPDATE_HEROCHALLENGE_TASK_INFO", self, self.updateTaskRedDot);
	self:addLuaEvent("UPDATE_HEROCHALLENGE_RANK_INFO", self, self.updateHeroChallengeRankInfo);
	self:addLuaEvent("REQUEST_HEROCHALLENGE_RANK_INFO", self, self.onRequestRankInfo);
	self:addLuaEvent("REQUEST_HEROCHALLENGE_RANKREWARD_INFO", self, self.onRequestRankRewardInfo);
	self:addLuaEvent("REQUEST_HEROCHALLENGE_CHALLENGE_INFO", self, self.onChallengeClick);

	DataCenter.heroChallengeData.isFirstEnter = false;
	Lua_ProxyManager.getProxy("Lua_OpenServerTrialProxy"):sHeroChallengeInfo();
end

function Lua_HeroChallengePanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
end

function Lua_HeroChallengePanel:setData(data)
	self.data = data;
	self:onRequestRankInfo(0);
end

function Lua_HeroChallengePanel:updateServerInfo()
	local heroChallengeData = DataCenter.heroChallengeData;
	self.titleIcon:setAltas(heroChallengeData.atlas, heroChallengeData.title);
	self.titleIcon:resetSize();

	self.rewardList.canDrag = #heroChallengeData.hero_list > 3
	self.rewardList:setArrayData(heroChallengeData.hero_list);

	local str = LanUtil.getValue(680001);
	local attrVo;
	for i = 1, #heroChallengeData.add_prop_list do
		attrVo = DataCenter.attributesUtil:createAttrVo(heroChallengeData.add_prop_list[i].name);
		str = str .. LanUtil.formateStr(680002, attrVo.show_name, heroChallengeData.add_prop_list[i].value * 100);
	end
	self.upAttrTxt.text = str;

	local stageReward = heroChallengeData.daily_hurt_reward;
	local curStageIdx = heroChallengeData.curStageIdx;
	local nextStageIdx = heroChallengeData.nextStageIdx;
	if heroChallengeData.daily_max_hurt <= 0 then
		self.hurtTxt.text = LanUtil.formateStr(680003, 0, stageReward[curStageIdx].hurt);
	else
		if heroChallengeData.daily_max_hurt > stageReward[#stageReward].hurt then
			self.hurtTxt.text = heroChallengeData.daily_max_hurt;
		else
			self.hurtTxt.text = LanUtil.formateStr(680003, heroChallengeData.daily_max_hurt, stageReward[nextStageIdx].hurt);
		end
	end

	local len = #stageReward[curStageIdx].item_list;
	local posX = len > 4 and 0 or (315 - len * 75) / 2;
	self.curRankList.canDrag = len > 4;
	self.curRankList:setArrayData(stageReward[curStageIdx].item_list);
	self.curRankList:setLocation(posX, 236, 0);
	self.curRankList:setEnable(nextStageIdx > curStageIdx or curStageIdx ~= 1);
	self.tipsTxt:setEnable(nextStageIdx == curStageIdx and curStageIdx == 1);

	local itemInfo = stageReward[nextStageIdx].item_list[1];
	local tvo = getConfig("item", itemInfo.id); -- Lua_ToolVo.createToolVo(itemInfo.id);
	self.preReadBtn:setAltas(tvo.atlas, tvo.sprite);

	local recordId = DataCenter.fightData:getRecordIdByTemplateId(Lua_FightDefine.TEMPLATE_ID_HEROCHALLENGE);
	if recordId > 0 then
		self.challengeBtn:setLangValue(680004);
	else
		self.challengeBtn:setLangValue(680005);
	end

	if self.monster_id and self.monster_id ~= heroChallengeData.monster_id then
		self:setModelShow();
	end
	self.monster_id = heroChallengeData.monster_id;

	self.showTime = heroChallengeData.residueTime;
	self:startTimer();
	self:updateLeftTime();
	self:showFightEff(recordId > 0);
	self:updateRewardRedDot(heroChallengeData.daily_reward_state == 1);
	self:updateTaskRedDot();
end

function Lua_HeroChallengePanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_HeroChallengePanel", 1, self, self.updateLeftTime);
	end
end

function Lua_HeroChallengePanel:updateLeftTime()
	self.showTime = self.showTime - 1;
	if self.showTime <= 0 then
		self.leftTimeTxt:setLangValue(680018);
		self:endTimer();
		return;
	end
	self.leftTimeTxt.text = LanUtil.formateStr(680000, Lua_TimeTransform.transSeconds18(self.showTime, true, true, true, false));
end

function Lua_HeroChallengePanel:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.updateLeftTime);
	end
end

function Lua_HeroChallengePanel:showFightEff(bShow)
	if bShow then
		if self.fightEff == nil then
			self.fightEff = UICreate.createUIEffect(self.uitweenObj_3, "/effects/uiEffects/ui_ty_zdbs_0101", "ui_ty_zdbs_0101", 190, 240);
			self.fightEff:setScale(0.5, 0.5, 0.5);
		end
		self.fightEff:setEnable(true);
	else
		if self.fightEff then
			self.fightEff:setEnable(false);
		end
	end
end

function Lua_HeroChallengePanel:updateRewardRedDot(bShow)
	if bShow then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.uitweenObj_3);
			self.redPoint:setLocation(-200, 253, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_HeroChallengePanel:updateTaskRedDot()
	if DataCenter.heroChallengeData.taskRedState then
		if self.taskRedPoint == nil then
			self.taskRedPoint = Lua_RedPointIcon.new(self.uitweenObj_3);
			self.taskRedPoint:setLocation(167, 84, 0);
			self.taskRedPoint:createRedPointEff();
		end
		self.taskRedPoint:updateRedPointShow(true);
	else
		if self.taskRedPoint ~= nil then
			self.taskRedPoint:updateRedPointShow(false);
		end
	end
end

function Lua_HeroChallengePanel:setModelShow(param)
	if self.modelScenePanel == nil then
		if param ~= nil then
			self.modelScenePanel = param;
		else
			self.modelScenePanel = Lua_ModelScenePanel.new();
		end
	end
	local monsterConfig = Lua_MonsterPlayerConfigData.getConfigData(DataCenter.heroChallengeData.monster_id);
	local monsterData = Lua_MonsterConfigData.getMonsterConfig(monsterConfig.fighter_list[1][1][1]);
	local heroVo = monsterData.heroVo;
	local sceneId = DataCenter.heroChallengeData.scene_id;
	self.modelScenePanel:setParent(self.content);
	self.modelScenePanel:setRotBgDimensions(720, 720);
	self.modelScenePanel:setRotBgPos(0, 195);

	self.modelScenePanel:setModelDir(heroVo.uiModelDir); -- 模型rotate
	self.modelScenePanel:setModelScale(heroVo.uiModelScale); -- 模型scale
	self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UIWAIT, heroVo.poseActEffs); -- ui待机wait
	self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UISHOW, heroVo.showActEffs); -- ui展示show
	self.modelScenePanel:showModelScene(sceneId, heroVo.uiModelUrl, heroVo.uiModelAvatarName, heroVo.uiModelCamController, true);
	self.modelScenePanel:setModelAct(heroVo.uiShowAct, Lua_ThingDefine.UIWAIT, true);
	self.modelScenePanel:setFurEffShow(self.classname, heroVo.bShowFur);
	self:showSkillFun(monsterData.skill_list);
end

function Lua_HeroChallengePanel:returnModel()
	if self.modelScenePanel ~= nil then
		self.modelScenePanel:dispose()
		self.modelScenePanel = nil
	end
end

function Lua_HeroChallengePanel:showSkillFun(skillList)
	if self.skillArr == nil then
		self.skillArr = Array();
	end

	local dataLen = skillList == nil and 0 or #skillList;
	local arr = Array();
	local configData;
	for i = 1, dataLen do
		configData = Lua_SkillConfigData.getConfigData(skillList[i]);
		if configData.show_type ~= 1 then
			arr:add(configData);
		end
	end

	dataLen = arr:getSize();
	local posList;
	if dataLen == 3 then
		posList = {{-185, 475}, {0, 460}, {185, 475}};
	elseif dataLen == 4 then
		posList = {{-238, 487}, {-80, 460}, {80, 460}, {238, 487}};
	elseif dataLen == 5 then
		posList = {{-304, 595}, {-185, 475}, {0, 460}, {185, 475}, {304, 595}};
	end

	local item;
	for i = 1, dataLen do
		item = self.skillArr[i];
		if item == nil then
			item = Lua_SkillIconItem.new(self.uitweenObj_3);
			item:setCanClick(true);
			self.skillArr:add(item);
		end
		item:setData(arr[i]);
		item:setLocation(posList[i][1], posList[i][2], 0);
		item:setScale(0.9, 0.9, 0.9);
	end
	arr:clear();
	arr = nil;
end

-- 更新前三名信息
function Lua_HeroChallengePanel:updateHeroChallengeRankInfo(msg)
	if msg == nil then
		return;
	end

	local list = msg.rank_list;
	-- table.sort( list, function(a, b) return a.rank < b.rank end);
	local item;
	for i = 1, 3 do
		item = self.rankArr[i];
		if item == nil then
			item = Lua_HeroChallengeRankMiniItem.new(self.uitweenObj_2);
			item:setLocation(-69, -64 - (i - 1) * 34, 0);
			self.rankArr:add(item);
		end
		item:setData(i, list[i]);
	end

	local rank, name;
	if msg.self_rank.rank == 0 then
		rank = LanUtil.getValue(680023);
		name = "";
	else
		rank = msg.self_rank.rank;
		name = msg.self_rank.player_show.name;
	end
	self.myRankInfoTxt.text = LanUtil.formateStr("{1}{2}{3}{4}", rank, Lua_SpaceDefine.SPACE, Lua_SpaceDefine.SPACE, name);
end

-- 请求排行信息
function Lua_HeroChallengePanel:onRequestRankInfo(page)
	if page == nil then
		return;
	end
	self:onHeroChallengeOperate(1, page);
end

-- 请求排行奖励信息
function Lua_HeroChallengePanel:onRequestRankRewardInfo()
	self:onHeroChallengeOperate(2);
end

-- 活动说明
function Lua_HeroChallengePanel:onRuleClick(go)
	local tipsData = { des = LanUtil.getValue(680006), posX = 180, posY = -270 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

-- 打开英雄挑战排行榜界面
function Lua_HeroChallengePanel:onAllRankClick(go)
	self:onHeroChallengeOperate(3);
end

-- 打开英雄挑战个人阶段伤害界面
function Lua_HeroChallengePanel:onPreviewClick(go)
	self:onHeroChallengeOperate(4);
end

-- 请求每日奖励
function Lua_HeroChallengePanel:onRewardClick(go)
	self:onHeroChallengeOperate(5);
end

-- 请求挑战任务
function Lua_HeroChallengePanel:onTaskClick(go)
	self:onHeroChallengeOperate(6);
end

function Lua_HeroChallengePanel:onChallengeClick(go)
	local recordId = DataCenter.fightData:getRecordIdByTemplateId(Lua_FightDefine.TEMPLATE_ID_HEROCHALLENGE);
	if recordId > 0 then
		DataCenter.fightData:showFightToStageByRid(recordId);
		return;
	end
	self:onHeroChallengeOperate(7);
end

function Lua_HeroChallengePanel:onHeroChallengeOperate(operateType, param)
	if operateType == 1 then
		Lua_ProxyManager.getProxy("Lua_OpenServerTrialProxy"):sHeroChallengeRankInfo(param);
	elseif operateType == 2 then
		Lua_ProxyManager.getProxy("Lua_OpenServerTrialProxy"):sHeroChallengeRankRewardInfo();
	elseif operateType == 3 then
		Lua_WindowUtil.openWin("Lua_HeroChallengeRankWindow", Lua_WinParam.ACTION_OPEN);
	elseif operateType == 4 then
		Lua_WindowUtil.openWin("Lua_HeroChallengeHurtRewardWindow", Lua_WinParam.ACTION_OPEN);
	elseif operateType == 5 then
		local drawState = DataCenter.heroChallengeData.daily_reward_state;
		if drawState == 0 then
			Lua_WindowUtil.openWin("Lua_HeroChallengeShowRewardWindow", Lua_WinParam.ACTION_OPEN, 1);
		elseif drawState == 1 then
			Lua_ProxyManager.getProxy("Lua_OpenServerTrialProxy"):sHeroChallengeDailyReward();
		else
			OperateAlert.showLangValue(680007);
		end
	elseif operateType == 6 then
		Lua_WindowUtil.openWin("Lua_HeroChallengeTaskWindow", Lua_WinParam.ACTION_OPEN);
	elseif operateType == 7 then
		local sceneId = DataCenter.heroLineupData:getFightLineupSceneId(Lua_FightDefine.TEMPLATE_ID_HEROCHALLENGE);
		DataCenter.preLoadData:preShowScene("Lua_BossOrHeroChallengeLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
	end
end

function Lua_HeroChallengePanel:onSceneShow(param, mp, success)
	if not success then return; end
	local data = Lua_LineupWinData.getData(Lua_FightDefine.TEMPLATE_ID_HEROCHALLENGE, DataCenter.heroChallengeData.monster_id);
	Lua_WindowUtil.openWin("Lua_BossOrHeroChallengeLineupWindow", Lua_WinParam.ACTION_OPEN, data);
end

function Lua_HeroChallengePanel:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.curRankList ~= nil then
		self.curRankList:dispose();
		self.curRankList = nil;
	end
	if self.rankArr ~= nil then
		self.rankArr:dispose();
		self.rankArr:clear();
		self.rankArr = nil;
	end
	if self.skillArr ~= nil then
		self.skillArr:dispose();
		self.skillArr:clear();
		self.skillArr = nil;
	end
	if self.fightEff ~= nil then
		self.fightEff:dispose();
		self.fightEff = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	if self.taskRedPoint ~= nil then
		self.taskRedPoint:dispose();
		self.taskRedPoint = nil;
	end
	self.data = nil;
	DataCenter.preLoadData:removeBySign(self.preSignStr, self, self.onPreLoaded);
	DataCenter.preLoadData:removeBySign("Lua_BossOrHeroChallengeLineupWindow", self, self.onSceneShow);
	self:returnModel();
	self:endTimer();
	
	self:superCall("dispose");
end










Lua_HeroChallengeHeroInfoItem = class("Lua_HeroChallengeHeroInfoItem", Lua_ItemIconCell);
function Lua_HeroChallengeHeroInfoItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.6, 0.6);
end










Lua_HeroChallengeRankMiniItem = class("Lua_HeroChallengeRankMiniItem", Lua_ListCell);
function Lua_HeroChallengeRankMiniItem:ctor(p)
	self:superCall("ctor", p, "HeroChallengeRankMiniItem_skin");
end

function Lua_HeroChallengeRankMiniItem:setData(rank, data)
	self.rankIcon:setAltas("boss_challenge_atlas", "xui_boos_label_"..rank);
	self.rankIcon:resetSize();

	if data == nil then
		self.nameTxt:setLangValue(680008);
	else
		self.nameTxt.text = data.player_show.name;
	end
end










Lua_HeroChallengeCurRankRewardItem = class("Lua_HeroChallengeCurRankRewardItem", Lua_ItemIconCell);
function Lua_HeroChallengeCurRankRewardItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.6, 0.6);
end