-- 开服试炼-英雄挑战排行奖励
Lua_HeroChallengeRankRewardWindow = class("Lua_HeroChallengeRankRewardWindow", Lua_Window);
function Lua_HeroChallengeRankRewardWindow:ctor(p)
	self:superCall("ctor");

	self.windowName = "Lua_HeroChallengeRankRewardWindow";
	self.skinName = "HeroChallengeRankRewardWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_HeroChallengeRankRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_DragList.new(self.content, 600, 690, Lua_AxisDefine.Vertical);
	self.itemList:setListCell(Lua_HeroChallengeRankRewardItem, 600, 120, 1);
	self.itemList:setLocation(0, -114, 0);
	self.itemList:setCellSpacing(0, 5);

	self:addLuaEvent("UPDATE_HEROCHALLENGE_RANKREWARD_INFO", self, self.updateShowInfo);
	Lua_MsgUtil.callFunc("REQUEST_HEROCHALLENGE_RANKREWARD_INFO");
end

function Lua_HeroChallengeRankRewardWindow:updateShowInfo()
	self.itemList:setArrayData(DataCenter.heroChallengeData.rank_reward);
end

function Lua_HeroChallengeRankRewardWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.myRewardList ~= nil then
		self.myRewardList:dispose();
		self.myRewardList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_HeroChallengeRankRewardItem = class("Lua_HeroChallengeRankRewardItem", Lua_ListCell);
function Lua_HeroChallengeRankRewardItem:ctor(p)
	self:superCall("ctor", p, "HeroChallengeRankRewardItem_skin");
end

function Lua_HeroChallengeRankRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 320, 87, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_HeroChallengeRankRewardIconItem, 87, 87, 1);
	self.rewardList:setLocation(51, 0, 0);
	self.rewardList:setCellSpacing(5, 0);
	self:setSubList(self.rewardList);
end

function Lua_HeroChallengeRankRewardItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	if data.rank_left == data.rank_right then
		self.rankBg:setAltas("common_altas_4", "xui_jys_label_1"..(data.rank_left - 1));
		self.rankTxt:setEnable(false);
	else
		self.rankTxt:setEnable(true);
		self.rankBg:setAltas("common_altas_4", "xui_jys_label_13");
		local rightStr = data.rank_right == 0 and "+" or "-"..data.rank_right;
		self.rankTxt.text = data.rank_left..rightStr;
	end

	local tvo;
	local tvoArr = Array();
	for i = 1, #data.reward do
		tvo = Lua_ToolVo.createToolVo(data.reward[i].key, data.reward[i].value);
		tvoArr:add(tvo);
	end
	self.rewardList:setArrayData(tvoArr);
	self.rewardList.canDrag = tvoArr:getSize() > 3;
end

function Lua_HeroChallengeRankRewardItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end










Lua_HeroChallengeRankRewardIconItem = class("Lua_HeroChallengeRankRewardIconItem", Lua_ItemIconCell)
function Lua_HeroChallengeRankRewardIconItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.7, 0.7);
end