-- 开服试炼-英雄降临
Lua_OpenServerHeroComeWindow = class("Lua_OpenServerHeroComeWindow", Lua_Window)
function Lua_OpenServerHeroComeWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_OpenServerHeroComeWindow";
	self.skinName = "OpenServerHeroComeWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
	self.heroUrl = "/images/activities/xui_kfyx_window_7.png";
	self:addPreLoadRes(self.heroUrl, Lua_LoadFileType.IMG);
end

function Lua_OpenServerHeroComeWindow:buildShowItem()
	self:superCall("buildShowItem");

	local heroUrlPos = DataCenter.openServerHeroComeData.heroUrlPos;
	-- self.heroImg.resetBgSize = true;
	self.heroImg:setUrl(self.heroUrl);
	self.heroImg:setLocation(heroUrlPos[1], heroUrlPos[2]);

	local heroNamePos = DataCenter.openServerHeroComeData.heroNamePos;
	self.nameIcon:resetSize();
	self.nameIcon:setLocation(heroNamePos[1], heroNamePos[2]);
	self.taskItemArr = Array();

	self.drawBtn:addClickFuntion(self, self.onDrawClick);
	self.reakHeroBtn:addClickFuntion(self, self.onReadHeroClick);

	self:addLuaEvent("UPDATE_HEROCOME_SHOWINFO", self, self.updateHeroComeInfo);
	self:addLuaEvent("HEROCOME_SHOW_NEWHERO", self, self.showHeroComeNewHero);
	Lua_ProxyManager.getProxy("Lua_OpenServerTrialProxy"):sHeroComeInfo()
end

function Lua_OpenServerHeroComeWindow:updateHeroComeInfo()
	local arr = DataCenter.openServerHeroComeData.taskVoArr;
	local item;
	local process = 0;
	for i = 1, arr:getSize() do
		taskVoInfo = DataCenter.openServerHeroComeData:getTaskVoById(arr[i]);
		item = self.taskItemArr[i];
		if item == nil then
			item = Lua_OpenServerHeroComeTaskItem.new(self.content);
			item:setLocation(-226 + (i - 1) * 225, -226);
			self.taskItemArr:add(item);
		end
		item:setData(taskVoInfo);

		if taskVoInfo and taskVoInfo.state ~= 0 then
			process = process + 1;
		end
	end
	local colorStr = process < arr:getSize() and "FF2E00" or "2CE654";
	self.processTxt.text = LanUtil.formateStr(670001, Lua_ColorDefine.getColorStr(colorStr, process), arr:getSize());

	self.leftTime = DataCenter.openServerHeroComeData.activeTime - DataCenter.roleData.serverTime;
	self:startActTimer();
	self:updateActTimer();
	self:updateRewardRedDot(DataCenter.openServerHeroComeData.heroDrawState == 1);
end

function Lua_OpenServerHeroComeWindow:startActTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_OpenServerHeroComeWindow", 1, self, self.updateActTimer);
	end
end

function Lua_OpenServerHeroComeWindow:updateActTimer()
	if self.leftTime <= 0 then
		self.timeTxt:setLangValue(670007);
		self:endActTimer();
		return;
	end
	local str = Lua_TimeTransform.transSeconds18(self.leftTime, true, true, true, true);
	self.timeTxt.text = LanUtil.formateStr(670000, str);
	self.leftTime = self.leftTime - 1;
end

function Lua_OpenServerHeroComeWindow:endActTimer()
	if self.bTimer == true then
		self.bTimer = false;
		Lua_CommonUtil.removeTimer(self, self.updateActTimer);
	end
end

function Lua_OpenServerHeroComeWindow:updateRewardRedDot(bShow)
	if bShow then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(-200, 57, 0);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_OpenServerHeroComeWindow:onDrawClick()
	if not DataCenter.funcOpenData:isOpened(10283) then
		OperateAlert.showLangValue(670008);
		return;
	end

	local state = DataCenter.openServerHeroComeData.heroDrawState;
	if state == 1 then
		Lua_ProxyManager.getProxy("Lua_OpenServerTrialProxy"):sHeroComeDrawHero();
	elseif state == 0 then
		OperateAlert.showLangValue(670004);
	else
		OperateAlert.showLangValue(670005);
	end
end

function Lua_OpenServerHeroComeWindow:onReadHeroClick()
	DataCenter.heroAtlasData:onOpenAtlasWindow(DataCenter.openServerHeroComeData.heroId, 1);
end

function Lua_OpenServerHeroComeWindow:showHeroComeNewHero(msg)
	if msg == nil or msg.is_new ~= 1 then
		return;
	end
	
	self.bShowNewHero = true;
	local heroVo = Lua_HeroVo.new(DataCenter.openServerHeroComeData.heroId);
    DataCenter.preLoadData:preShowModelScene("Lua_RecruitShowSingleHeroWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onShowModel, heroVo, heroVo);
end

function Lua_OpenServerHeroComeWindow:onShowModel(param, modelScenePanel, issuccess)
	if issuccess then
		param.modelScenePanel = modelScenePanel;
	    Lua_WindowUtil.openWin("Lua_RecruitShowSingleHeroWindow", Lua_WinParam.ACTION_OPEN, param);
	end
end

function Lua_OpenServerHeroComeWindow:removeShowModel()
	if self.bShowNewHero == true then
		DataCenter.preLoadData:removeBySign("Lua_RecruitShowSingleHeroWindow", self, self.onShowModel);
	end
end

function Lua_OpenServerHeroComeWindow:dispose()
	if self.taskItemArr ~= nil then
		self.taskItemArr:dispose();
		self.taskItemArr:clear();
		self.taskItemArr = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self:removeShowModel();
	self:endActTimer();
	self:superCall("dispose");
end










Lua_OpenServerHeroComeTaskItem = class("Lua_OpenServerHeroComeTaskItem", Lua_DisplayObject)
function Lua_OpenServerHeroComeTaskItem:ctor(p)
	self:superCall("ctor", p, "OpenServerHeroComeTaskItem_skin");
end

function Lua_OpenServerHeroComeTaskItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setCanClick(true);
	self.itemIcon:setLocation(0, 80, 0);
	self.itemIcon:setScale(0.74, 0.74);

	self.drawBtn:addClickFuntion(self, self.onDrawClick);
end

function Lua_OpenServerHeroComeTaskItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(data.showReward[1], data.showReward[2]);
	self.itemIcon:setData(tvo);
	self.itemIcon:setDrawMask(data.state == 2);

	local colorStr = data.state == 0 and "ED4C30" or "479154";
	self.descTxt.text = LanUtil.formateStr(data.desc, Lua_ColorDefine.getColorStr(colorStr, data.curProcess));

	if data.state == 0 then
		self.itemBg:setAltas("openServerTrial_atlas", "xui_kfyx_window_8");
		self.drawBtn:setLangValue(670002);
	elseif data.state == 1 then
		self.itemBg:setAltas("openServerTrial_atlas", "xui_kfyx_window_9");
		self.drawBtn:setLangValue(670003);
	else
		self.itemBg:setAltas("openServerTrial_atlas", "xui_kfyx_window_8");
	end
	self.drawBtn:setStyle(data.state == 0 and 7 or 5);
	self.drawBtn:setEnable(data.state ~= 2);
	self.drawIcon:setEnable(data.state == 2);
	self:updateRewardRedDot(data.state == 1);
end

function Lua_OpenServerHeroComeTaskItem:updateRewardRedDot(bShow)
	if bShow then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(58, -91, 0);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_OpenServerHeroComeTaskItem:onDrawClick()
	if not DataCenter.funcOpenData:isOpened(10283) then
		OperateAlert.showLangValue(670008);
		return;
	end
	if self._data == nil then
		return;
	end

	if self._data.state == 0 then
		if self._data.eventId == nil then
			if self._data.id == 1 then
				-- OperateAlert.showLangValue();
			elseif self._data.id == 2 then
				OperateAlert.showLangValue(670006);
			elseif self._data.id == 3 then
				-- OperateAlert.showLangValue();
			end
			return;
		end
		DataCenter.funcPathUtil:gotoFunction(self._data.eventId, true);
	elseif self._data.state == 1 then
		Lua_ProxyManager.getProxy("Lua_OpenServerTrialProxy"):sHeroComeDrawTask(self._data.id);
	end
end

function Lua_OpenServerHeroComeTaskItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end