--开服竞技
Lua_OpenServiceAthleticsPanel = class("Lua_OpenServiceAthleticsPanel", Lua_DisplayObject);
function Lua_OpenServiceAthleticsPanel:ctor(p)
	self:superCall("ctor", p, "OpenServiceAthletics_skin");
end

function Lua_OpenServiceAthleticsPanel:buildShowItem()
	self:superCall("buildShowItem");
	
	self.rewardList = Lua_DragList.new(self.content, 698, 764 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.rewardList:setListCell(Lua_OpenServiceAthleticsRewardItem, 698, 170, 1);
    self.rewardList:setLocation(0, -419);
	self.rewardList:setCellSpacing(0, 10);
	self.rewardList:setRectPivot(1);
	self.rewardList:setRectAnchor(1);
	self.rewardList.tweenId = 2014;
	self.rewardList.delayTween = true;

	self.rankList = Lua_DragList.new(self.content, 694, 576 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.rankList:setListCell(Lua_OpenServiceAthleticsRankItem, 694, 121, 1);
	self.rankList:setRectPivot(1);
	self.rankList:setRectAnchor(1);
	self.rankList:setCellSpacing(0, 6);
    self.rankList:setLocation(0, -461);
	self.rankList.tweenId = 2014;
	-- self.rankList.callBackOwner = self;
	-- self.rankList.turnPageCallBack = self.turePage;

	self.downTabInfo = Array();
    self.downTabInfo:add({textStr = LanUtil.getValue(400016), tagType = 1}); -- 奖励
    self.downTabInfo:add({textStr = LanUtil.getValue(400017), tagType = 2}); -- 排名

    --奖励/排行页签
    self.downBtnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
    self.downBtnList:setRectAnchor(7);
    self.downBtnList:setLocation(0, 210, 0);
    self.downBtnList:setButtonItem(130, 66);
    self.downBtnList:setButtonCell(Lua_OpenAthleticsButtonItem);
	self.downBtnList:setClickCallBack(self, self.onDownTabBtnClick);
    self.downBtnList:setData(self.downTabInfo);

	-- self.topTabInfo = Array();
 --    self.topTabInfo:add({textStr = LanUtil.getValue(400014), tagType = Lua_OpenServiceAthleticsData.STAR }); -- 星数排行
 --    self.topTabInfo:add({textStr = LanUtil.getValue(400015), tagType = Lua_OpenServiceAthleticsData.TIER }); -- 层数排行
 --    self.topTabInfo:add({textStr = LanUtil.getValue(400020), tagType = Lua_OpenServiceAthleticsData.FORCE }); -- 战力排行
 	self.topTabInfo = DataCenter.OpenServiceAthleticsData:getShowTabArr();

    --星数/层数/战力页签
    self.topBtnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
    self.topBtnList:setRectPivot(3)
    self.topBtnList:setRectAnchor(1);
    self.topBtnList:setLocation(-367, -367, 0);
    self.topBtnList:setButtonItem(190, 52);
    self.topBtnList:setButtonStyle("common_altas_4","xui_kfjj_toggle_002_b","xui_kfjj_toggle_002_f",176,52);
    self.topBtnList:setButtonText(0, 0, "f5dbb1", "8f5123", 28, 28, Lua_MyUISettings.huakangFontName, UnityEngine.FontStyle.Normal);
    self.topBtnList:setClickCallBack(self, self.onTopTabBtnClick);
    self.topBtnList:setData(self.topTabInfo);
    self.topBtnList:setSelected(1);--默认选择

    self:sendMsg(true);
    self.helpBtn:addClickFuntion(self, self.onHelpBtnClick);
	self:addLuaEvent("UPDATE_ATHLETICS_INFO", self, self.updateAthleticsPanel);
end

function Lua_OpenServiceAthleticsPanel:onScreenResize(adaptHeight)
	if self.adaptHeight ~= adaptHeight then
		self:superCall("onScreenResize", adaptHeight);

    	self.rewardList:setContentRect(698, 764 + self.adaptHeight);
		self.rankList:setContentRect(694, 576 + self.adaptHeight);
	end
end

--星数/层数/战力页签
function Lua_OpenServiceAthleticsPanel:onTopTabBtnClick(val)
	if self.selectedTopIndex == val then
		return;
	end

	self.selectedTopIndex = val;
	local topTagType = self:getTopTagType(self.selectedTopIndex);
	DataCenter.OpenServiceAthleticsData.curTopIndex = topTagType;

	self.selectedDownIndex = nil;
	self.downBtnList.selectedIdx = nil;
	self.downBtnList:setSelected(1);--默认选择

	local cfg = getConfig("open_arena_tab", topTagType);
	if cfg ~= nil then
		self.title_spr:setAltas(cfg.title_altas, cfg.title_sprite);
		self.title_spr:resetSize();
	end
	self:playTopTween();
end

--奖励/排行页签
function Lua_OpenServiceAthleticsPanel:onDownTabBtnClick(val)
	if self.selectedDownIndex == val then 
		return;
	end
	self.selectedDownIndex = val;

	local type = self.downTabInfo[val].tagType;
	if type == 1 then -- 奖励
		self:updateRewardLsit();
	elseif type == 2 then -- 排名
		self:sendMsg(true);
	end
end

function Lua_OpenServiceAthleticsPanel:updateAthleticsPanel(msg)
	self:startTimer();
	if self.selectedDownIndex == 2 then
		self:updateRankList(msg);
	end
end

function Lua_OpenServiceAthleticsPanel:getTopTagType(index)
	if index ~= nil and self.topTabInfo[index] ~= nil then
		return self.topTabInfo[index].tagType;
	end
end

-- 奖励
function Lua_OpenServiceAthleticsPanel:updateRewardLsit()
	local topTagType = self:getTopTagType(self.selectedTopIndex);
	local arr = DataCenter.OpenServiceAthleticsData:getRewardsInfo(topTagType);
	self.rewardList:setArrayData(arr);
	self.rewardList:setEnable(true);
	self.rankList:setEnable(false);
    self.noRankObj:SetActive(false);
    self.titleObj:SetActive(false);
	self.myRankObj:SetActive(false);
	if self.headItem ~= nil then
		self.headItem:setEnable(false);
	end

	self.rewardList:moveToIndex(1,true);
	self.rewardList.showTween = true;
end

-- 排名
function Lua_OpenServiceAthleticsPanel:updateRankList(msg)
	self:dealwithRankData(msg.rank_list);
	-- self.rankList.isPageEnd = (msg.is_end == 1);

	self.rankList:setArrayData(self.rankData);
	self.rankList:setEnable(true);
	self.rewardList:setEnable(false);
	self.titleObj:SetActive(true);
	self.myRankObj:SetActive(true);

	local topTagType = self:getTopTagType(self.selectedTopIndex);
	if topTagType == Lua_OpenServiceAthleticsData.STAR then
		self.starOrTierText:setLangValue(400007);
	elseif topTagType == Lua_OpenServiceAthleticsData.TIER then
		self.starOrTierText:setLangValue(400008);
	elseif topTagType == Lua_OpenServiceAthleticsData.FORCE then
		self.starOrTierText:setLangValue(400021);
	end

	self.noRankObj:SetActive(self.rankData == nil or self.rankData:getSize() <= 0);
	self:updateSelfRankInfo(msg.self_list);

	if not self.bAddRank then
		self.rankList:moveToIndex(1, true);
		self.rankList.showTween = true;
	end
end

function Lua_OpenServiceAthleticsPanel:dealwithRankData(data)
	if self.rankData == nil then
		self.rankData = Array();
	end

	local msgCount = #data;
	if not self.bAddRank then
		local count = self.rankData:getSize();
		local residueCount = count - msgCount;
		while(residueCount > 0) do
			self.rankData:remove();
			residueCount = residueCount - 1;
		end

		for i = 1, msgCount do
			if i > count then
				self.rankData:add(data[i]);
			else
				self.rankData[i] = data[i];
			end
		end
	else
		for i = 1, msgCount do
			self.rankData:add(data[i]);
		end
	end
end

-- function Lua_OpenServiceAthleticsPanel:turePage()
-- 	self:sendMsg();
-- end

function Lua_OpenServiceAthleticsPanel:sendMsg(bChangeRankType)
	if self.topTabInfo ~= nil and self.topTabInfo[self.selectedTopIndex] ~= nil then
		local topTagType = self:getTopTagType(self.selectedTopIndex);
		local pageType = bChangeRankType and 0 or 1;
		self.bAddRank = not bChangeRankType;
		Lua_ProxyManager.getProxy("Lua_LimitedTimeActivityProxy"):sOpenServiceAthleticsInfo(topTagType, pageType);
	end
end

function Lua_OpenServiceAthleticsPanel:playTopTween()
	LuaUtil.setObjPos(self.topObj, 0, -520, 0);
	TweenUtil.getInstance():stop(self.topObj);
	TweenUtil.getInstance():addTweenTargetPos(self.topObj, 0.5, 0, 0, -720, 0, 0, false);
end

--更新自己的排行信息
function Lua_OpenServiceAthleticsPanel:updateSelfRankInfo(data)
	if data == nil then
		return;
	end

	self.playerId = tonumber(data.player_show.id);
	self.serviceFlag = tonumber(data.player_show.server_flag);
	local rank = data.rank == 0 and LanUtil.getValue(400011) or data.rank;
	local size = data.rank == 0 and 26 or 50;
	self.rank_txt.text = rank;
	self.rank_txt.fontSize = size;
	self.name_txt.text = data.player_show.name;

	local league_name = data.player_show.league_name;
	if league_name == nil or league_name == "" then
		self.tips_txt:setLangValue(400005);
    else
		self.tips_txt.text = LanUtil.formateStr(400004, league_name);
    end

    if DataCenter.OpenServiceAthleticsData.curTopIndex == Lua_OpenServiceAthleticsData.FORCE then
    	self.num_txt.pivotValue = 3;
		self.num_txt:setLocation(144, 326);

		self.forceSp:setEnable(true);
	else
		self.num_txt.pivotValue = 4;
		self.num_txt:setLocation(286, 326);

		self.forceSp:setEnable(false);
	end
    self.num_txt.text = data.value;

    if self.headItem == nil then
    	self.headItem = Lua_AvatarItem.new(self.content);
    	self.headItem:setRectAnchor(7);
    	self.headItem:setScale(0.75,0.75);
		self.headItem:setLocation(-156, 326);
	end
	self.headItem:setEnable(true);
	self.headItem:setRoleDressUp(data.player_show.dress_info);
	self.headItem:setRoleLevel(data.player_show.level);
    self.headItem:setAvatarClick(self, self.onHeadClick);
end

function Lua_OpenServiceAthleticsPanel:onHeadClick()
	if self.playerId == DataCenter.roleData.roleId then
		OperateAlert.showLangValue(400006);
	else
		Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOtherRoleId(self.playerId, self.serviceFlag);
	end
end

function Lua_OpenServiceAthleticsPanel:startTimer(closeTime)
	self.showTime = DataCenter.OpenServiceAthleticsData.end_time;
	self:showActiveTime();
	if self.bStarTimer ~= true then
		self.bStarTimer = true;
		self:addTimer("OnAthleticsTimeDown", 1, self, self.showActiveTime);
	end
end

function Lua_OpenServiceAthleticsPanel:showActiveTime()
	local time = self.showTime - DataCenter.roleData.serverTime;
	local str;
	if time > 0 then
		str = Lua_TimeTransform.transSeconds16(time, true, true, true);
	else
		str = "";
		self:endTime();
	end
	self.activeTimeText.text = LanUtil.formateStr(400018, str);
end

function Lua_OpenServiceAthleticsPanel:endTime()
	if self.bStarTimer == true then 
		self.bStarTimer = false;
		Lua_CommonUtil.removeTimer(self, self.showActiveTime);
	end
end

function Lua_OpenServiceAthleticsPanel:onHelpBtnClick()
	local tipData = {des = LanUtil.getValue(400019), posX = 204, posY = -217};
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_OpenServiceAthleticsPanel:dispose()
	DataCenter.OpenServiceAthleticsData.curTopIndex = nil;
	if self.rankList ~= nil then
		self.rankList:dispose();
		self.rankList = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.headItem ~= nil then
		self.headItem:dispose();
		self.headItem = nil;
	end
	if self.topBtnList ~= nil then
		self.topBtnList:dispose();
		self.topBtnList = nil;
	end
	if self.downBtnList ~= nil then
		self.downBtnList:dispose();
		self.downBtnList = nil;
	end
	if self.rankData ~= nil then
		self.rankData:dispose();
		self.rankData:clear();
		self.rankData = nil;
	end
	if self.downTabInfo ~= nil then
		self.downTabInfo:dispose();
		self.downTabInfo:clear();
		self.downTabInfo = nil;
	end
	self:endTime();

	TweenUtil.getInstance():stop(self.topObj);
	self:superCall("dispose");
end





























Lua_OpenServiceAthleticsRewardItem = class("Lua_OpenServiceAthleticsRewardItem", Lua_ListCell);
function Lua_OpenServiceAthleticsRewardItem:ctor(p)
	self:superCall("ctor", p, "OpenServiceAthleticsRewardItem_skin");
end

function Lua_OpenServiceAthleticsRewardItem:buildShowItem()
	self:superCall("buildShowItem");
	self.rewardIconList = Lua_ItemIconList.new(self.content);
	self.rewardIconList.pivot = 1;
	self.rewardIconList.scaleVal = 0.75;
	self.rewardIconList:setLayout(138, 0, 100);
	self.rewardIconList:setLocation(-274, -20, 0);
end

function Lua_OpenServiceAthleticsRewardItem:setData(id)
	self.data = DataCenter.OpenServiceAthleticsData:getOpenArenaVoById(id);
	if self.data == nil then
		return
	end

	local leftValue = self.data.range[1];
	local rightValue = self.data.range[2];
	self.rewardIconList:setArrayData(self.data.reward_item);
	if self.data.type == Lua_OpenServiceAthleticsData.STAR then
		if leftValue == rightValue then
			if self.data.complete ~= nil then
				self.rankText.text = LanUtil.formateStr(400000, leftValue, self.data.complete);
		    else
				self.rankText.text = LanUtil.formateStr(400012, leftValue);
		    end
		else
			if self.data.complete ~= nil then
				self.rankText.text = LanUtil.formateStr(400001, leftValue, rightValue, self.data.complete);
		    else
				self.rankText.text = LanUtil.formateStr(400013, leftValue, rightValue);
		    end
		end  
	elseif self.data.type == Lua_OpenServiceAthleticsData.TIER then
		if leftValue == rightValue then
			if self.data.complete ~= nil then
				self.rankText.text = LanUtil.formateStr(400002, leftValue, self.data.complete);
		    else
				self.rankText.text = LanUtil.formateStr(400012, leftValue);
		    end
		else
			if self.data.complete ~= nil then
				self.rankText.text = LanUtil.formateStr(400003, leftValue, rightValue, self.data.complete);
		    else
				self.rankText.text = LanUtil.formateStr(400013, leftValue, rightValue);
		    end
		end
	elseif self.data.type == Lua_OpenServiceAthleticsData.FORCE then
		if leftValue == rightValue then
			if self.data.complete ~= nil then
				self.rankText.text = LanUtil.formateStr(400022, leftValue, self.data.complete);
		    else
				self.rankText.text = LanUtil.formateStr(400012, leftValue);
		    end
		else
			if self.data.complete ~= nil then
				self.rankText.text = LanUtil.formateStr(400023, leftValue, rightValue, self.data.complete);
		    else
				self.rankText.text = LanUtil.formateStr(400013, leftValue, rightValue);
		    end
		end
	end
end

function Lua_OpenServiceAthleticsRewardItem:onPressClick()
	if self.pressItem == nil then
		return;
	end
	self.pressItem:onItemClick(nil);
end

function Lua_OpenServiceAthleticsRewardItem:checkClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.rewardIconList.mainContent);
    for i = 1, self.rewardIconList.showArr:getSize() do
        if self.rewardIconList.showArr[i].isActive and self.rewardIconList.showArr[i]:checkInBound(winPos.x, winPos.y) then
            return self.rewardIconList.showArr[i];
        end
    end
    return nil;
end

function Lua_OpenServiceAthleticsRewardItem:onMouseDownHandle()
	self.pressItem = self:checkClick();
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.71, 0.71);
	end
end

function Lua_OpenServiceAthleticsRewardItem:onMouseUpHandle()
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.75, 0.75);
	end
end

function Lua_OpenServiceAthleticsRewardItem:dispose()
	if self.rewardIconList ~= nil then
		self.rewardIconList:dispose();
		self.rewardIconList = nil;
	end
	if self.pressItem ~= nil then
		self.pressItem:dispose();
		self.pressItem = nil;
	end
	self:superCall("dispose");
end



























Lua_OpenServiceAthleticsRankItem = class("Lua_OpenServiceAthleticsRankItem", Lua_ListCell)
function Lua_OpenServiceAthleticsRankItem:ctor(p)
	self:superCall("ctor", p, "OpenServiceAthleticsRankItem_skin");
end

function Lua_OpenServiceAthleticsRankItem:buildShowItem()
	self:superCall("buildShowItem");

	self.headItem = Lua_AvatarItem.new(self.content);
	self.headItem:setScale(0.75,0.75);
	self.headItem:setLocation(-156, 0);
end

function Lua_OpenServiceAthleticsRankItem:setData(data)
	if data == nil then
		return
	end

	if DataCenter.OpenServiceAthleticsData.curTopIndex == Lua_OpenServiceAthleticsData.FORCE then
		self.starNumText:setLocation(144, 3);
		self.starNumText.pivotValue = 3;
		self.starNumText.alignmentValue = 3;
		self.starNumText.text = data.value;

		self.forceSp:setEnable(true);
	else
		self.starNumText:setLocation(243, 3);
		self.starNumText.pivotValue = 4;
		self.starNumText.alignmentValue = 4;
		self.starNumText.text = data.value;

		self.forceSp:setEnable(false);
	end

	self.playerId = tonumber(data.player_show.id);
	self.serviceFlag = data.player_show.server_flag;
	if data.rank <= 3 then
		self.rankNumText:setEnable(false);
		self.rank_icon:setAltas("common_altas_4","xui_jys_label_"..9 + data.rank);
	else
		self.rankNumText.text = data.rank;
		self.rankNumText:setEnable(true);
		self.rank_icon:setAltas("common_altas_4","xui_jys_label_13");
	end

	self.nameText.text = data.player_show.name;

	local league_name = data.player_show.league_name;
	if league_name == nil or league_name == "" then
		self.communityText:setLangValue(400005);
    else
		self.communityText.text = LanUtil.formateStr(400004, league_name);
    end

    self.headItem:setRoleDressUp(data.player_show.dress_info);
    self.headItem:setRoleLevel(data.player_show.level);
    self.headItem:setAvatarClick(self, self.onHeadClick);
end

function Lua_OpenServiceAthleticsRankItem:onHeadClick()
	if self.playerId == DataCenter.roleData.roleId then
		OperateAlert.showLangValue(400006);
	else
		Lua_ProxyManager.getProxy("Lua_RoleProxy"):sOtherRoleId(self.playerId, self.serviceFlag);
	end
end

function Lua_OpenServiceAthleticsRankItem:dispose()
	if self.headItem ~= nil then
		self.headItem:dispose();
		self.headItem = nil;
	end
	self:superCall("dispose");
end





















Lua_OpenAthleticsButtonItem = class("Lua_OpenAthleticsButtonItem", Lua_ButtonCell)
function Lua_OpenAthleticsButtonItem:ctor(p)
	self:superCall("ctor", p)
end

function Lua_OpenAthleticsButtonItem:buildShowItem()
	self:superCall("buildShowItem")
	self.bg_spr = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0)
	self.bg_spr.clickScale = false;
	self.bg_spr:addClickFuntion(self, self.onPressClick)

	self.name_txt = UICreate.createLabel(self.content, nil, 0, 0, 200, 40, 32);
    self.name_txt.pivot = UIUtils.Pivot.Center;
    self.name_txt.fontName = Lua_MyUISettings.huakangFontName;
    self.name_txt.alignmentValue = 4;
end

function Lua_OpenAthleticsButtonItem:dispose()
	self.data = nil;
	self.bg_spr = nil;
	self.name_txt = nil;
	self:superCall("dispose")
end

function Lua_OpenAthleticsButtonItem:setData(data)
    self.data = data;
end

function Lua_OpenAthleticsButtonItem:setSelected(index)
	if index == self.index then
		self.bg_spr:SetDimensions(188,67);
		self.bg_spr:setScale(0.9,0.9,0.9);
		self:setSiblingIndex(1);
		self.bg_spr:setAltas("common_altas_1", "xui_common_button_004_n");
		self.name_txt.text = Lua_ColorDefine.getColorStr("8f5123",self.data.textStr);
	else
		self:setSiblingIndex(0);
		self.bg_spr:SetDimensions(172,61);
		self.bg_spr:setScale(1,1,1);
		self.bg_spr:setAltas("common_altas_4", "xui_kfjj_widget_4");
		self.name_txt.text = Lua_ColorDefine.getColorStr("eee8ea",self.data.textStr);
	end
end