-- 超值基金（本地）
Lua_SpecialFundsPanel = class("Lua_SpecialFundsPanel", Lua_DisplayObject);
function Lua_SpecialFundsPanel:ctor(p)
	self:superCall("ctor", p, "SpecialFundsPanel_skin");
end

function Lua_SpecialFundsPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardBg:SetDimensions(711, 644 + self.adaptHeight);
	self.instantTxt_1:setLangValue(203005);
	self.instantTxt_2:setLangValue(203006);
	self.instantTxt_1:resetSize();
	self.instantTxt_2:resetSize();

	self.showList = Lua_DragList.new(self.uitweenObj_1, 340, 89, Lua_AxisDefine.Horizontal);
	self.showList:setListCell(Lua_SpecialFundsIconItem, 89, 89, 1);
	self.showList:setCellSpacing(10, 0);
	self.showList:setRectPivot(3);
	self.showList:setLocation(-340, -280, 0);

	self.rewardList = Lua_DragList.new(self.content, 665, 608 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.rewardList.tweenId = 2003;
	self.rewardList.delayTween = true;
	self.rewardList:setListCell(Lua_SpecialFundsItem, 133, 159, 5);
	self.rewardList:setSiblingIndex(5);
	self.rewardList:setCellSpacing(0, 11);
	self.rewardList:setLocation(0, -29, 0);

	local list = DataCenter.specialFundsData.rechargeIdList;
	local len = #list;
	local width = len > 2 and 678 or len * 257;
	self.btnBg:SetDimensions(width, 62);

	local posX = len > 2 and 0 or (660 - 248 * len) / 2;
	self.btnList = Lua_DragList.new(self.content, 660, 62, Lua_AxisDefine.Horizontal);
	self.btnList.canDrag = len > 3;
	self.btnList.clickMoveOffset = 1;
	self.btnList:setListCell(Lua_SpecialFundsButtonItem, 248, 62, 1);
	self.btnList:setRectAnchor(7);
	self.btnList:setLocation(posX, 221, 0);
	self.btnList:setArrayData(list);

	self.instantTxt_1:addUrlClickFuntion(self, self.onUrlClickFun);
	self.rechargeBtn:addClickFuntion(self, self.onSureBtnClick)

	self:addLuaEvent("UPDATE_SPECIALFUNDS_INFO", self, self.updateSpecialFundsInfo);
	self:addLuaEvent("ON_SPECIALFUNDS_BTNCLICK", self, self.onBtnClick);
	Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sSpecialFundsInfo(); -- 激活月卡后，是否可充值要申请
end

function Lua_SpecialFundsPanel:setData(actVo)
end

function Lua_SpecialFundsPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	self.rewardBg:SetDimensions(711, 644 + adaptHeight);
	self.rewardList:setContentRect(665, 608 + adaptHeight);
end

function Lua_SpecialFundsPanel:onBtnClick(btnData)
	if self.gradeType == btnData[2] then
		return;
	end
	self.rechargeId = btnData[1];
	self.gradeType = btnData[2];
	self.rewardList.showTween = true;

	self.totalValueTxt.text = DataCenter.specialFundsData.totalReward[self.gradeType][2][2]; -- 总价值
	self.instantValueTxt.text = DataCenter.specialFundsData.instantReward[self.gradeType][2][1][2]; -- 立得奖励
	self.instantValueTxt:resetSize();
	self.icon_2:setLocation(self.instantTxt_1.posX + self.instantTxt_1.width + 9, 1, 0);
	self.instantValueTxt:setLocation(self.icon_2.posX + self.icon_2.width + 5, 0, 0);
	self.instantTxt_2:setLocation(self.instantValueTxt.posX + self.instantValueTxt.width + 7, 0, 0);
	local posX = (self.instantTxt_2.posX + self.instantTxt_2.width + self.instantTxt_1.posX) / 2;
	LuaUtil.setObjPos(self.desObj, -posX, -375, 0);

	self:startTimer();
	self:updateLeftTime();
	self:updateSpecialFundsInfo();
end

function Lua_SpecialFundsPanel:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		self:addTimer("Lua_SpecialFundsPanel", 1, self, self.updateLeftTime);
	end
end

function Lua_SpecialFundsPanel:updateLeftTime()
	local time = DataCenter.specialFundsData.remainTime;
	self.leftTimeTxt.text = LanUtil.formateStr(203009, Lua_TimeTransform.transSeconds18(time, true, true, true, false));
	if time <= 0 then
		self:endTimer();
	end
end

function Lua_SpecialFundsPanel:endTimer()
	if self.countDown == true then
		self.countDown = false;
		self:removeTimer(self, self.updateLeftTime);
	end
end

function Lua_SpecialFundsPanel:updateSpecialFundsInfo()
	self.gradeInfo = DataCenter.specialFundsData:getFundsVoInfo(self.gradeType);
	if self.gradeInfo == nil then
		if not self.isFirst then
			self.isFirst = true;
			self.btnList:setSelected(2); -- 策划要求默认选择豪华礼包
			self.btnList:setSelectClick(2);
		end
		return;
	end

	local arr = DataCenter.specialFundsData:getShowFundsInfoArr(self.gradeType);
	self.showList:setArrayData(arr);

	self.rewardList:setArrayData(self.gradeInfo.rewardList);
	self.rewardList:moveToIndex(self.gradeInfo.hasDrawDay + 1, true);

	local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self.rechargeId);
	if not self.gradeInfo.lockState then -- 未解锁
		self.rechargeBtn.label = LanUtil.formateStr(203000, rechargeInfo.money);
		self.rechargeBtn:setGray(false);
	else
		if self.gradeInfo.hasDrawDay < DataCenter.specialFundsData.curDrawDay and self.gradeInfo.hasDrawDay < #self.gradeInfo.rewardList then
			self.rechargeBtn:setLangValue(203001);
			self.rechargeBtn:setGray(false);
		else
			self.rechargeBtn:setLangValue(203002);
			self.rechargeBtn:setGray(true);
		end
	end

	self.tipsTxt.text = LanUtil.formateStr(203008, DataCenter.specialFundsData.curDrawDay);
	self.tipsObj:SetActive(not self.gradeInfo.lockState);
	self:showDrawRedDot(self.gradeInfo.lockState and self.gradeInfo.fundsRedState);
end

function Lua_SpecialFundsPanel:showDrawRedDot(bShow)
	if bShow then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setRectAnchor(7);
			self.redPoint:setLocation(108, 335, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_SpecialFundsPanel:onUrlClickFun(urlStr)
	local arr = string.split(urlStr, "_");
	if arr and arr:getSize() > 0 then
		DataCenter.funcPathUtil:gotoFunction(tonumber(arr[1]), true);
	end
end

function Lua_SpecialFundsPanel:onSureBtnClick(go)
	if self.gradeInfo then
		if self.gradeInfo.lockState then
			if self.gradeInfo.hasDrawDay < DataCenter.specialFundsData.curDrawDay and self.gradeInfo.hasDrawDay < #self.gradeInfo.rewardList then
				Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sSpecialFundsReward(self.gradeInfo.gradeType);
			else
				OperateAlert.showLangValue(203003);
			end
		else
			if self.gradeInfo.rechargeState then
				local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self.rechargeId);
				DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
					tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
			else
				OperateAlert.showLangValue(203007);
			end
		end
	end
end

function Lua_SpecialFundsPanel:dispose()
	if self.showList ~= nil then
		self.showList:dispose();
		self.showList = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.gradeInfo = nil;
	self:endTimer();
	self:superCall("dispose");
end










Lua_SpecialFundsIconItem = class("Lua_SpecialFundsIconItem", Lua_ItemIconCell);
function Lua_SpecialFundsIconItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.71, 0.71);
end










Lua_SpecialFundsItem = class("Lua_SpecialFundsItem", Lua_ListCell)
function Lua_SpecialFundsItem:ctor(p)
	self:superCall("ctor", p, "SpecialFundsItem_skin");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setSiblingIndex(2);
	self.itemIcon:setLocation(0, -17, 0);
	self.itemIcon:setScale(0.92, 0.92);

	self.itemBg:addLoadCompleteFun(self, self.onLoadCompletedFun);
end

function Lua_SpecialFundsItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local day = data.key % 1000;
	if day <= DataCenter.specialFundsData.curDrawDay then
		self.itemBg:setAltas("funds_atlas", "xui_czjz2_widget_4");
	else
		self.itemBg:setAltas("funds_atlas", "xui_czjz2_widget_3");
	end
	self.dayTxt.text = LanUtil.formateStr(203004, day);

	local rewardKey = DataCenter.specialFundsData.rewardKey;
	local config = DataCenter.specialFundsData:getFundsInfo(data.key);
	local tvo = Lua_ToolVo.createToolVo(config[rewardKey][1], config[rewardKey][2]);
	self.itemIcon:setData(tvo);
	self.itemIcon:showEffect(false);

	self.drawIcon:setEnable(data.value == 2);
	self:showEffect(config.is_effect == 1 and data.value ~= 2);

	local gradeType = Mathf.Floor(data.key / 10000);
	self.gradeInfo = DataCenter.specialFundsData:getFundsVoInfo(gradeType);
	self:showItemRedDot(self.gradeInfo.lockState and data.value == 1);
end

function Lua_SpecialFundsItem:showEffect(bShow)
	if bShow then
		if self.itemEff == nil then
			self.itemEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_iconeffect_02", "ui_iconeffect_02", 0, -17);
			self.itemEff.siblingIndex = 3;
			self.itemEff:setScale(0.92, 0.92);
		end
		self.itemEff:setEnable(true);
	else
		if self.itemEff then
			self.itemEff:setEnable(false);
		end
	end
end

function Lua_SpecialFundsItem:showItemRedDot(bShow)
	if bShow then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(49, 67, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_SpecialFundsItem:onPressClick(go)
	if self._data then
		if self.gradeInfo.lockState and self._data.value == 1 then
			Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sSpecialFundsReward(self.gradeInfo.gradeType);
		else
			self.itemIcon:onItemClick();
		end
	end
end

function Lua_SpecialFundsItem:onLoadCompletedFun()
	self.itemBg:resetSize();
end

function Lua_SpecialFundsItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.itemEff ~= nil then
		self.itemEff:dispose();
		self.itemEff = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self._data = nil;
	self.gradeInfo = nil;
	self:superCall("dispose");
end










Lua_SpecialFundsButtonItem = class("Lua_SpecialFundsButtonItem", Lua_ListCell)
function Lua_SpecialFundsButtonItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_SpecialFundsButtonItem:buildShowItem()
	self:superCall("buildShowItem");

	self.nameBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_button_007_n", 0, 0, 297, 67);
	self.nameBg:setScale(0.86, 0.86, 1);

	self.nameTxt = UICreate.createLabel(self.content, nil, 0, 3, 100, 31, 28);
	self.nameTxt.pivotValue = 4;
	self.nameTxt.alignmentValue = 4;
	self.nameTxt.horizontalOverflowValue = 1;
	self.nameTxt.verticalOverflowValue = 1;
	self.nameTxt.fontName = Lua_MyUISettings.huakangFontName;

	self:addLuaEvent("UPDATE_SPECIALFUNDS_INFO", self, self.showBtnRedDot);
end

function Lua_SpecialFundsButtonItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.nameTxt.text = data[3];
	self:showBtnRedDot();
end

function Lua_SpecialFundsButtonItem:showBtnRedDot()
	local gradeInfo = DataCenter.specialFundsData:getFundsVoInfo(self._data[2]);
	if gradeInfo and gradeInfo.lockState and gradeInfo.fundsRedState then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(114, 14, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_SpecialFundsButtonItem:onPressClick()
	if self._data then
		Lua_MsgUtil.callFunc("ON_SPECIALFUNDS_BTNCLICK", self._data);
	end
	return true;
end

function Lua_SpecialFundsButtonItem:onSelectionChange(bSelect)
	self:superCall("onSelectionChange", bSelect);

	local colorStr = bSelect and "594D4D" or "BBACA1";
	self.nameBg:setEnable(bSelect);
	self.nameTxt.colorStr = Lua_ColorDefine.transColor(colorStr);
end

function Lua_SpecialFundsButtonItem:dispose()
	if self.nameBg ~= nil then
		self.nameBg:dispose();
		self.nameBg = nil;
	end
	if self.nameTxt ~= nil then
		self.nameTxt:dispose();
		self.nameTxt = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self._data = nil;
	self:superCall("dispose")
end