-- 升星专属(开服)(本地)
Lua_UpStarOfServerPanel = class("Lua_UpStarOfServerPanel", Lua_DisplayObject);
function Lua_UpStarOfServerPanel:ctor(p)
	self:superCall("ctor", p, "UpStarOfServerPanel_skin");
end

function Lua_UpStarOfServerPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.selectHeroIcon = Lua_ItemIcon.new(self.content);
	self.selectHeroIcon:setLocation(-220, -200);
	self.selectHeroIcon:setSiblingIndex(4);
	self.selectHeroIcon:setRectAnchor(1);

	self.giftList = Lua_DragList.new(self.content, 720, 700 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.giftList:setListCell(Lua_UpStarOfServerRewardItem, 720, 152, 1);
	self.giftList:setCellSpacing(0, 10);
	self.giftList:setLocation(0, -165, 0);

	self.ruleBtn:addClickFuntion(self, self.onRuleClick);
	self.selectIcon:addClickFuntion(self, self.onSelectHeroClick);
	self.sureBtn:addClickFuntion(self, self.onSureClick);

	self:addLuaEvent("UPDATE_UPSTAROFSERVER_INFO", self, self.updateUpStarOfServerData);
	Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sUpStarOfServerInfo();
end

function Lua_UpStarOfServerPanel:setData(data)
end

function Lua_UpStarOfServerPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	self.giftList:setContentRect(720, 700 + adaptHeight);
end

function Lua_UpStarOfServerPanel:updateUpStarOfServerData()
	local upStarOfServerData = DataCenter.upStarOfServerData;
	self.addIcon:setEnable(upStarOfServerData.heroState == 0);
	self.reSelectIcon:setEnable(upStarOfServerData.heroState == 1);
	self.selectHeroIcon:setData(upStarOfServerData.curSelectHero);

	if upStarOfServerData.heroState ~= 2 then
		self.sureBtn:setLangValue(203100);
		self.sureBtn:setStyle(17);
	else
		self.sureBtn:setLangValue(203101);
		self.sureBtn:setStyle(18);
	end
	self.giftList:setArrayData(DataCenter.upStarOfServerData.rewardArr);
	
	self:startTimer();
	self:updateLeftTime();
end

function Lua_UpStarOfServerPanel:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_UpStarOfServerPanel", 1, self, self.updateLeftTime);
	end
end

function Lua_UpStarOfServerPanel:updateLeftTime()
	local time = DataCenter.upStarOfServerData.endTimes - DataCenter.roleData.serverTime;
	if time <= 0 then
		time = 0;
		self:endTimer();
	end
	self.leftTimeTxt.text = LanUtil.formateStr(203102, Lua_TimeTransform.transSeconds16(time, true, true, true));
end

function Lua_UpStarOfServerPanel:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateLeftTime);
	end
end

function Lua_UpStarOfServerPanel:onRuleClick(go)
    local tipData = { des = LanUtil.getValue(203103), posX = 160, posY = -260 };
    Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_UpStarOfServerPanel:onSelectHeroClick(go)
	if DataCenter.upStarOfServerData.heroState ~= 2 then
		local showHeroArr = DataCenter.upStarOfServerData:getHeroListArr();
		if showHeroArr:getSize() == 0 then
			local quality = DataCenter.upStarOfServerData.constConfig.lock_hero_cond[1];
			local quality_star = DataCenter.upStarOfServerData.constConfig.lock_hero_cond[2];
			OperateAlert.show(LanUtil.formateStr(203104, DataCenter.heroUtil:getHeroQualityName(quality, quality_star)));
			return;
		end
		Lua_WindowUtil.openWin("Lua_UpStarOfServerSelectHeroWindow", Lua_WinParam.ACTION_OPEN);
	else
		OperateAlert.showLangValue(203105);
	end
end

function Lua_UpStarOfServerPanel:onSureClick(go)
	if DataCenter.upStarOfServerData.heroState ~= 2 then
		if DataCenter.upStarOfServerData.heroState == 1 then
			local tipData = {
				titleAtlas = "friend_altas",
				titleSprite = "ui_hy_title_02",
				des = LanUtil.getValue(203106),
				btnType = 1,
				owner = self,
				sureFun = self.onSureLockClick
			};
			Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
		else
			local showHeroArr = DataCenter.upStarOfServerData:getHeroListArr();
			if showHeroArr:getSize() == 0 then
				local quality = DataCenter.upStarOfServerData.constConfig.lock_hero_cond[1];
				local quality_star = DataCenter.upStarOfServerData.constConfig.lock_hero_cond[2];
				OperateAlert.show(LanUtil.formateStr(203104, DataCenter.heroUtil:getHeroQualityName(quality, quality_star)));
			else
				OperateAlert.showLangValue(203107);
			end
		end
	else
		OperateAlert.showLangValue(203105);
	end
end

function Lua_UpStarOfServerPanel:onSureLockClick(go)
	local vo = DataCenter.upStarOfServerData.curSelectHero;
	Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sUpStarOfServerAddHero(vo.id, 2, vo.quality, vo.quality_star);
end

function Lua_UpStarOfServerPanel:dispose()
	if self.selectHeroIcon ~= nil then
		self.selectHeroIcon:dispose();
		self.selectHeroIcon = nil;
	end
	if self.giftList ~= nil then
		self.giftList:dispose();
		self.giftList = nil;
	end
	self:endTimer();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_UpStarOfServerRewardItem = class("Lua_UpStarOfServerRewardItem", Lua_ListCell);
function Lua_UpStarOfServerRewardItem:ctor(p)
	self:superCall("ctor", p, "UpStarOfServerRewardItem_skin");
end

function Lua_UpStarOfServerRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.freeIcon = Lua_ItemIcon.new(self.content);
	self.freeIcon:setLocation(-140, 0);
	self.freeIcon:setScale(0.8, 0.8);
	self.freeIcon:setSiblingIndex(3);

	self.rewardList = Lua_DragList.new(self.content, 240, 115, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_ServerRechargeRewardItem, 112, 112, 1);
	self.rewardList:setRectPivot(3);
	self.rewardList:setLocation(-45, -2, 0);
	self:setSubList(self.rewardList);

	self.rechargeBtn:addClickFuntion(self, self.onRechargeClick);
end

function Lua_UpStarOfServerRewardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.condTipsTxt.text = DataCenter.heroUtil:getHeroQualityName(data.quality, data.qualityStar);
	local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(data.rechargeId);
	self.rechargeBtn.label = LanUtil.formateStr(203108, tonumber(rechargeInfo.money));
	self.limitCountTxt.text = LanUtil.formateStr(203109, data.rechargeTimes, data.totalRechargeTimes);

	local upStarOfServerData = DataCenter.upStarOfServerData;
	local isCond = upStarOfServerData.quality >= data.quality and upStarOfServerData.qualityStar >= data.qualityStar;
	if upStarOfServerData.heroId == 0 then
		self.condIcon:setGray(true);
		self.limitCountTxt:setEnable(false);
	else
		self.condIcon:setGray(upStarOfServerData.heroState ~= 2 or not isCond);
		self.limitCountTxt:setEnable(upStarOfServerData.heroState == 2 and data.rechargeTimes > 0);
	end

	local info = data.freeReward;
	local vo = upStarOfServerData.curSelectHero;
	local tvo;
	if info[1] <= 2 then
		if vo ~= nil then
			if info[1] == 0 then -- 0本体，1本体碎片，2阵营礼包
				tvo = Lua_ToolVo.createToolVo(vo.itemId, info[2]);
			elseif info[1] == 1 then
				tvo = Lua_ToolVo.createToolVo(vo.chipId, info[2]);
			elseif info[1] == 2 then 
				local campGiftInfo = upStarOfServerData.constConfig.camp_gift_list[vo.campType];
				tvo = Lua_ToolVo.createToolVo(campGiftInfo[2], info[2]);
			end
		end
	else
		tvo = Lua_ToolVo.createToolVo(info[1], info[2]);
	end
	self.freeIcon:setData(tvo);
	self.freeIcon:showEffect(upStarOfServerData.heroState == 2);
	self.freeIcon:setDrawMask(data.freeTimes <= 0, "investment_atlas", "xui_czjz_label_1");

	self.rewardList.canDrag = data.personRewardArr:getSize() >= 3;
	self.rewardList:setArrayData(data.personRewardArr);

	if upStarOfServerData.heroState ~= 2 then
		self.rechargeBtn:setStyle(3);
	else
		self.rechargeBtn:setStyle(isCond and 1 or 3);
	end
	self.noSelectIcon:setEnable(info[1] <= 2 and upStarOfServerData.heroState == 0);
	self.rechargeBtn:setEnable(data.rechargeTimes > 0);
	self.sellOutIcon:setEnable(data.rechargeTimes <= 0);
end

function Lua_UpStarOfServerRewardItem:onPressClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	if self.freeIcon:checkInBound(winPos.x, winPos.y) then
		self:onBtnClick();
	end
end

function Lua_UpStarOfServerRewardItem:onBtnClick()
	local upStarOfServerData = DataCenter.upStarOfServerData;
	if self._data.freeTimes > 0 then
		if upStarOfServerData.heroState == 2 then
			if upStarOfServerData.quality >= self._data.quality and upStarOfServerData.qualityStar >= self._data.qualityStar then
				Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sReceiveUpStarOfServerGift(self._data.id);
			else
				OperateAlert.showLangValue(203110);
			end
			return;
		end

		if self.freeIcon.data ~= nil then
			DataCenter.packUtil:showItemInfo(self.freeIcon.data);
		else
			if upStarOfServerData.heroState == 0 then
				OperateAlert.showLangValue(203111);
			elseif upStarOfServerData.heroState == 1 then
				OperateAlert.showLangValue(203112);
			end
		end
	else
		DataCenter.packUtil:showItemInfo(self.freeIcon.data);
	end
end

function Lua_UpStarOfServerRewardItem:onRechargeClick(go)
	local upStarOfServerData = DataCenter.upStarOfServerData;
	if upStarOfServerData.heroState ~= 2 then
		OperateAlert.showLangValue(203113);
	else
		if upStarOfServerData.quality >= self._data.quality and upStarOfServerData.qualityStar >= self._data.qualityStar then
			local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self._data.rechargeId);
			DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
				tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
		else
			OperateAlert.showLangValue(203114);
		end
	end
end

function Lua_UpStarOfServerRewardItem:dispose()
	if self.freeIcon ~= nil then
		self.freeIcon:dispose();
		self.freeIcon = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_ServerRechargeRewardItem = class("Lua_ServerRechargeRewardItem", Lua_ListCell);
function Lua_ServerRechargeRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_ServerRechargeRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rechargeIcon = Lua_ItemIcon.new(self.content);
	self.rechargeIcon:setScale(0.8, 0.8);
	self.rechargeIcon:setSiblingIndex(0);

	self.noSelectIcon = UICreate.createUIAtlasImage(self.content, "equipcopy_atlas_1", "xui_jmd_widget_25", 0, 0, 0, 0);
end

function Lua_ServerRechargeRewardItem:setData(data)
	if data == nil then
		return;
	end

	local upStarOfServerData = DataCenter.upStarOfServerData;
	local tvo;
	if data.key <= 2 then
		local vo = upStarOfServerData.curSelectHero;
		if vo ~= nil then
			if data.key == 0 then -- 0本体，1本体碎片，2阵营礼包
				tvo = Lua_ToolVo.createToolVo(vo.itemId, data.value);
			elseif data.key == 1 then
				tvo = Lua_ToolVo.createToolVo(vo.chipId, data.value);
			elseif data.key == 2 then 
				local campGiftInfo = upStarOfServerData.constConfig.camp_gift_list[vo.campType];
				tvo = Lua_ToolVo.createToolVo(campGiftInfo[2], data.value);
			end
		end
	else
		tvo = Lua_ToolVo.createToolVo(data.key, data.value);
	end
	self.rechargeIcon:setData(tvo);
	self.rechargeIcon:setDrawMask(data.times <= 0, "investment_atlas", "xui_czjz_label_1");

	self.noSelectIcon:setEnable(data.key <= 2 and upStarOfServerData.heroState == 0);
end

function Lua_ServerRechargeRewardItem:onPressClick(go)
	if self.rechargeIcon.data ~= nil then
		DataCenter.packUtil:showItemInfo(self.rechargeIcon.data);
	else
		OperateAlert.showLangValue(203111);
	end
end

function Lua_ServerRechargeRewardItem:dispose()
	if self.rechargeIcon ~= nil then
		self.rechargeIcon:dispose();
		self.rechargeIcon = nil;
	end
	if self.noSelectIcon ~= nil then
		self.noSelectIcon:dispose();
		self.noSelectIcon = nil;
	end
	self:superCall("dispose");
end