Lua_VipPanel = class("Lua_VipPanel", Lua_DisplayObject);
function Lua_VipPanel:ctor(p)
	self:superCall("ctor", p, "VipPanel_skin");
end

function Lua_VipPanel:buildPanel()
	self:superCall("buildPanel")

	self:addLuaEvent("VIPLEVEL_SELECT", self, self.updatePanelInfo);
	self:addLuaEvent("SET_VIPPANEL_INFO", self, self.setPanelData);
	self:addLuaEvent("GET_VIPGIFT_SUCCEED", self, self.setPanelEvent);
end

function Lua_VipPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.btnIndex = -1;
	self.bar.typeValue = 3;
	self.bar.fillMethodValue = 0;
	self.bar.fillOrigin = 0;
	self.infoBg:SetDimensions(720, 690 + self.adaptHeight);
	self.showBg:SetDimensions(499, 674 + self.adaptHeight);
	self.desBg:SetDimensions(466, 282 + self.adaptHeight);

	self.btnList = Lua_DragList.new(self.uitweenObj_3, 207, 674 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.btnList:setListCell(Lua_VipBtnItem, 207, 128, 1);
	self.btnList:setRectAnchor(1);
	self.btnList:setCellSpacing(0, 4);
	self.btnList:setLocation(-251.5, -919 - self.adaptHeight / 2, 0);

	self.dragContainer = Lua_DragContainer.new(self.uitweenObj_4, 450, 270 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.dragContainer:setRectAnchor(1);
	self.dragContainer:setLocation(106, -807 - self.adaptHeight / 2, 0);

	self.rewardList = Lua_DragList.new(self.uitweenObj_4, 430, 75, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_VipRewardSubItem, 86, 75, 1);
	self.rewardList:setRectAnchor(7);
	self.rewardList:setLocation(106, 388, 0);

	self.tipIcon:addClickFuntion(self, self.onTipIconClick);
	self.goBtn:addClickFuntion(self, self.onGoBtnClick);
	self.buyBtn:addClickFuntion(self, self.onBuyBtnClick);

    DataCenter.redPointData:updateRedPointState(Lua_RedPointList.RaccoonMart_EachLoginVip, false, true);

	self:setPanelEvent();
end

function Lua_VipPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);

	self.infoBg:SetDimensions(720, 690 + adaptHeight);
	self.showBg:SetDimensions(499, 674 + adaptHeight);
	self.desBg:SetDimensions(466, 282 + adaptHeight);

	self.btnList:setContentRect(207, 674 + adaptHeight);
	self.btnList:setLocation(-251.5, -919 - adaptHeight / 2, 0);

	self.dragContainer:setContentRect(450, 270 + adaptHeight);
	self.dragContainer:setLocation(106, -807 - adaptHeight / 2, 0);

	if self.dragContainer ~= nil then
		self.dragContainer.canDrag = not self.dragContainer.isTheEnd;
	end
end

function Lua_VipPanel:setPanelEvent()
	Lua_ProxyManager.getProxy("Lua_VipProxy"):sGetVipPanelInfo();
end

function Lua_VipPanel:setPanelData()
	self.isUpdate = true;
	local vipData = DataCenter.vipData;
	local voArr = vipData.vipVoArr;
	self.btnList:setArrayData(voArr);

	local showIdx;
	if vipData.isPos then
		vipData.isPos = false;
		showIdx = vipData.level + 1;
	end

	if showIdx == nil then
		if self.btnIndex == -1 then
			showIdx = vipData:getBtnSelectIndex();
		else
			showIdx = self.btnIndex;
		end
	end

	if self.isFirstIn == nil then
		self.isFirstIn = true;
		self.btnList:moveToIndex(showIdx, true);
	end

	if self.btnIndex == -1 or self.btnIndex ~= showIdx then 
		self.btnList:setSelectClick(showIdx);
		self.btnList:setSelected(showIdx);
	else
		local vo = voArr[showIdx];
		if vo ~= nil then
			self:updatePanelInfo(vo);
		end
	end

	local vipInfo;
	if vipData.level >= vipData.maxVipLevel then
		vipInfo = vipData:getVipVoByLevel(vipData.maxVipLevel);
	else
		vipInfo = vipData:getVipVoByLevel(vipData.level + 1);
	end

	self.bar:setMaxValue(vipInfo.target);
	self.bar:setValue(vipData.vipExp);
	if vipData.level >= vipData.maxVipLevel and vipData.vipExp >= vipInfo.target then
		self.bar:setText(vipInfo.target .. "/" .. vipInfo.target);
	else
		self.bar:setText(vipData.vipExp .. "/" .. vipInfo.target);
	end

	self.levelTxt.text = vipData.level;
	if vipData.level == 0 then
		if self.vipNum ~= nil then
			self.vipNum:setEnable(false);
		end
		self.titleName:setAltas("vip_atlas", "ui_vip_title_13");
		self.titleName:SetDimensions(152, 90);
		self.titleName:setLocation(-339, -130, 0);
	else
		if self.vipNum == nil then
			self.vipNum = Lua_NumberImage.new(self.uitweenObj_1);
			self.vipNum.preStr = "ui_vip_title_0";
			self.vipNum.pivot = 1;
			self.vipNum.numOffsetX = -30;
			self.vipNum:setLocation(-352, -130, 0);
		end
		self.vipNum:setEnable(true);
		self.vipNum.num = vipData.level;

		self.titleName:setAltas("vip_atlas", "ui_vip_title_11");
		self.titleName:SetDimensions(167, 76);
		self.titleName:setLocation(-352 + self.vipNum.totalWidth -16, -137, 0);
	end
end

function Lua_VipPanel:updatePanelInfo(data)
	if self.btnIndex == data.id + 1 and self.isUpdate == false then
		return;
	end
	self.btnIndex = data.id + 1;
	self.isUpdate = false;
	self.data = data;

	if data.id == 0 then
		self.titleTxt:setLangValue(320000);
	else
		self.titleTxt.text = LanUtil.formateStr(320001, data.id);
	end

	local str;
	if data.rewardState == 0 then
		self.lockTxt:setEnable(true);
		str = spliceIconStrById(Lua_ResourcesDefine.VIP_EXP);
		self.lockTxt.text = LanUtil.formateStr(320002, str, data.target);

		self.buyObj:SetActive(false);
	else
		self.lockTxt:setEnable(false);
		self.buyObj:SetActive(true);

		if self.costVo == nil then
			self.costVo = Lua_ToolVo.createToolVo(data.last_cost[1]);
		else
			self.costVo:setData(data.last_cost[1]);
		end
		self.costIcon:setAltas(self.costVo.iconAtlas, self.costVo.iconSprite);
		self.costIcon:SetDimensions(self.costVo.iconWidth, self.costVo.iconHeight);
		self.costCount.text = data.last_cost[2];
		self.costCount:resetSize();
		self.priceLine:SetDimensions(self.costCount.width, 2);

		self.discountBg:setEnable(data.discount > 0);
		self.discountTxt:setEnable(data.discount > 0);
		self.discountTxt.text = LanUtil.formateStr(320004, data.discount);

		if data.rewardState == 1 then
			self.buyBtn:setStyle(20);
			str = spliceIconStrById(data.buy_cost[1]);
			self.buyBtn.label = LanUtil.formateStr(320005, str, data.buy_cost[2]);
			self.buyBtn:setMouseEnable(true);
		else
			self.buyBtn:setStyle(23);
			self.buyBtn:setLangValue(320006);
			self.buyBtn:setMouseEnable(false);
		end
	end

	self.dragContainer:clearList();
	local arr = string.split(data.privilege_des, "\n");
	for i = 1, arr:getSize() do
		self.dragContainer:addSubContainer(Lua_VipPrivilegeItem, arr[i]);
	end
	self.dragContainer:updateChildPos();
	self.dragContainer:moveToIndex(1, true, false);
	self.dragContainer.canDrag = not self.dragContainer.isTheEnd;

	local len = #data.vip_reward;
	local posX = len > 5 and 106 or 106 + (430 - 86 * len) / 2;
	self.rewardList.canDrag = len > 5;
	self.rewardList:setArrayData(data.vip_reward);
	self.rewardList:setLocation(posX, 388, 0);
end

function Lua_VipPanel:onBuyBtnClick(go)
	if self.data.rewardState == 0 then
		return;
	end

	if DataCenter.moneyData:isMoneyEnough(Lua_ResourcesDefine.DIAMOND, self.data.buy_cost[2], true, false, false) == false then
		DataCenter.funcPathUtil:gotoFunction(1024)
		return;
	end
	Lua_ProxyManager.getProxy("Lua_VipProxy"):sGetGiftReward(self.data.id);
end

function Lua_VipPanel:onTipIconClick(go)
	local tipsData = { des = LanUtil.getValue(320007), posX = 205, posY = -245 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_VipPanel:onGoBtnClick(go)
	local funcPathId = DataCenter.vipData:getConstConfig("func_path_id", 1);
	DataCenter.funcPathUtil:gotoFunction(funcPathId)
end

function Lua_VipPanel:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.vipNum ~= nil then
		self.vipNum:dispose();
		self.vipNum = nil;
	end
	self.costVo = nil;
	self.data = nil;
	
	self:superCall("dispose");
end











Lua_VipBtnItem = class("Lua_VipBtnItem", Lua_ListCell);
function Lua_VipBtnItem:ctor(p)
	self:superCall("ctor", p, "VipBtnItem_skin");
end

function Lua_VipBtnItem:buildShowItem()
	self:superCall("buildShowItem");

	self.lockIcon.alpha = 0.3;
	self.itemIcon = UICreate.createUIAtlasImage(self.content, "", "", 33, -10, 0, 0);
	self.itemIcon.siblingIndex = 1;
end

function Lua_VipBtnItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.titleTxt.text = LanUtil.formateStr(320008, data.id);
	self.itemTxt.text = data.vip_btn_des[1];

	local itemVo = Lua_ToolVo.new(data.vip_btn_des[2]);
	self.itemIcon:setAltas(itemVo.atlas, itemVo.sprite);
	self.itemIcon:resetSize();

	if itemVo.isIntactHero ~= nil then
		self.itemIcon:setScale(0.85, 0.85);
	else
		self.itemIcon:setScale(1, 1);
	end

	self.signTxt:setEnable(DataCenter.vipData.level == data.id);
	self.lockIcon:setEnable(data.rewardState == 0);

	self:checkRedDot(data.rewardState == 1);
end

function Lua_VipBtnItem:onPressClick()
	Lua_MsgUtil.callFunc("VIPLEVEL_SELECT", self.data);
	return true;
end

function Lua_VipBtnItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val then
		self.btnBg:setAltas("vip_atlas", "xui_vip_widget_1");
		self.itemTxt.colorStr = Lua_ColorDefine.transColorStr("5E4B42");
		self.signTxt.colorStr = Lua_ColorDefine.transColorStr("5E4B42");
	else
		self.btnBg:setAltas("vip_atlas", "xui_vip_widget_2");
		self.itemTxt.colorStr = Lua_ColorDefine.transColorStr("ECE7E9");
		self.signTxt.colorStr = Lua_ColorDefine.transColorStr("A6A1A0");
	end
end

function Lua_VipBtnItem:checkRedDot(bShow)
	if self.redDotEff == nil then
		self.redDotEff = Lua_RedPointIcon.new(self.content);
		self.redDotEff:createRedPointImg();
		self.redDotEff:setLocation(92, 52, 0);
	end
	self.redDotEff:updateRedPointShow(bShow)
end

function Lua_VipBtnItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.redDotEff ~= nil then
		self.redDotEff:dispose();
		self.redDotEff = nil;
	end
	self.data = nil;
	
	self:superCall("dispose");
end










Lua_VipPrivilegeItem = class("Lua_VipPrivilegeItem", Lua_DragContainerItem);
function Lua_VipPrivilegeItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_VipPrivilegeItem:buildShowItem()
	self:superCall("buildShowItem");

	self.icon = UICreate.createUIAtlasImage(self.content, nil, nil, -180, 0, 0, 0);
	self.icon.pivot = UIUtils.Pivot.Right;
	self.newLab = UICreate.createLabel(self.content, "", -200, 2, 0, 30, 22);
	self.newLab.alignmentValue = 4;
	self.newLab.horizontalOverflowValue = 1;

	self.label = UICreate.createLabel(self.content, nil, -175, 0, 200, 35, 24);
	self.label.alignmentValue = 0;
	self.label.pivot = UIUtils.Pivot.Left;
	self.label.fontStyle = UnityEngine.FontStyle.Bold;
	self.label.horizontalOverflowValue = 1;
end

function Lua_VipPrivilegeItem:setData(data)
	local startIdx, endIdx = string.find(data, "〖", 1);
	if startIdx ~= nil then
		self.icon:setAltas("vip_atlas", "ui_vip_label_03");
		self.newLab:setLangValue(320009);
	else
		self.icon:setAltas("vip_atlas", "ui_vip_label_01");
		self.newLab.text = "";
	end
	self.icon:resetSize();

	local des = string.gsub(data, "〖", "");
	self.label.text = LanUtil.formateStr(des, "5E4B42", "459252");
end

function Lua_VipPrivilegeItem:getWidth()
	return 450;
end

function Lua_VipPrivilegeItem:getHeight()
	return 43;
end

function Lua_VipPrivilegeItem:dispose()
	if self.icon ~= nil then
		self.icon:dispose();
		self.icon = nil;
	end
	if self.newLab ~= nil then
		self.newLab:dispose();
		self.newLab = nil;
	end
	if self.label ~= nil then
		self.label:dispose();
		self.label = nil;
	end
	self:superCall("dispose");
end










Lua_VipRewardSubItem = class("Lua_VipRewardSubItem", Lua_ItemIconCell);
function Lua_VipRewardSubItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_VipRewardSubItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon:setScale(0.60, 0.60);
end