-- 战令Item基类
checkRequire("Lua_WarOrderRewardItem");
Lua_WarOrderBaseItem = class("Lua_WarOrderBaseItem", Lua_ListCell);
function Lua_WarOrderBaseItem:ctor(p)
	self:superCall("ctor", p, "WarOrderBaseItem_skin");
end

function Lua_WarOrderBaseItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardItem = Lua_WarOrderRewardItem.new(self.content);
	self.rewardItem:setLocation(-157, 1.5, 0);

	self.rewardList = Lua_DragList.new(self.content, 240, 93, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_WarOrderRewardItem, 93, 93, 1);
	self.rewardList:setCellSpacing(14, 0);
	self.rewardList:setRectPivot(3);
	self.rewardList:setLocation(20, 1.5, 0);
	self:setSubList(self.rewardList);
end

function Lua_WarOrderBaseItem:setData(data)
	if data == nil then
		return;
	end

	local isCond = data.id <= DataCenter.warOrderData.curLvlId;
	local color = isCond and "825129" or "55473F";
	self.targetTxt.text = data.show_cond;
	self.targetTxt.colorStr = Lua_ColorDefine.transColorStr(color);

	local spriteName = isCond and "xui_zl_widget_5" or "xui_zl_widget_4";
	self.targetBg:setAltas("war_order_atlas", spriteName);
	
	self.rewardItem:setData(data.norRewardVo[1]);

	self.rewardList.canDrag = data.advRewardVo:getSize() > 2;
	self.rewardList:setArrayData(data.advRewardVo);
	self.rewardList:moveToIndex(1, true, false);

	local isNotActive = not DataCenter.warOrderData:curAdvActState(data.step);
	self.lockIcon:setEnable(isNotActive);
end

function Lua_WarOrderBaseItem:onPressClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	self.rewardItem:checkOnPress(winPos.x, winPos.y);
end

function Lua_WarOrderBaseItem:dispose()
	if self.rewardItem ~= nil then
		self.rewardItem:dispose();
		self.rewardItem = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end