-- 战令购买弹窗
Lua_WarOrderBuyWindow = class("Lua_WarOrderBuyWindow", Lua_Window);
function Lua_WarOrderBuyWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_WarOrderBuyWindow";
	self.skinName = "WarOrderBuyWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_WarOrderBuyWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.soonList = Lua_DragList.new(self.content, 440, 93, Lua_AxisDefine.Horizontal);
	self.soonList:setListCell(Lua_WarOrderBuyRewardItem, 93, 93, 1);
	self.soonList:setRectPivot(3);
	self.soonList:setCellSpacing(11, 0);
	self.soonList:setLocation(0, 81, 0);

	self.rewardList = Lua_DragList.new(self.content, 440, 93, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_WarOrderBuyRewardItem, 93, 93, 1);
	self.rewardList:setCellSpacing(11, 0);
	self.rewardList:setRectPivot(3);
	self.rewardList:setLocation(0, -70, 0);

	self.buyBtn:addClickFuntion(self, self.onBuyBtnClick);
end

function Lua_WarOrderBuyWindow:showWin(param)
	self:superCall("showWin", param);

	local curType = DataCenter.warOrderData.curType;
	local iconInfo = DataCenter.warOrderUtil:getIconInfo(curType);
	self.showIcon:setAltas(iconInfo[1], iconInfo[2]);
	self.showIcon:resetSize();

	self.titleTxt.text = DataCenter.warOrderUtil:getNameDes(curType);

	local isAddOther = false;
	local endIdx;
	local addCfg = DataCenter.warOrderUtil:getInfoByType(curType);
	if addCfg ~= nil and addCfg.up_level ~= nil then
		isAddOther = true;
		endIdx = addCfg.up_level;
		self.tipTxt.text = LanUtil.formateStr(550007, addCfg.up_level);
	end
	
	local arr = self:getShowRewardArr(isAddOther, endIdx);
	local width = (arr:getSize() - 1) * 104 + 93;
	local posX = width > 440 and -220 or -width / 2;
	self.soonList.canDrag = arr:getSize() > 4;
	self.soonList:setArrayData(arr);
	self.soonList:setLocation(posX, 81, 0);

	arr = DataCenter.warOrderData:getCumsumRewardArr(param);
	width = (arr:getSize() - 1) * 104 + 93;
	posX = width > 440 and -220 or -width / 2;
	self.rewardList.canDrag = arr:getSize() > 4;
	self.rewardList:setArrayData(arr);
	self.rewardList:setLocation(posX, -70, 0);

	local rechargeId = DataCenter.warOrderUtil:getRechargeId(curType, param);
	self.rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(rechargeId);
	self.buyBtn.label = LanUtil.formateStr(550001, self.rechargeInfo.money);
end

function Lua_WarOrderBuyWindow:getShowRewardArr(isAddOther, endIdx)
	local curType = DataCenter.warOrderData.curType;
	local list = DataCenter.warOrderUtil:getRechargeReward(curType, self.showData);
	local itemDic = {};
	-- 充值立得的
	if type(list) == "table" then
		for i = 1, #list do
			itemDic[list[i][1]] = list[i][2];
		end
	end

	-- 当前高级战令满足领取却未解锁的
	local rewardVoArr = DataCenter.warOrderData:getWarOrderVoArr(self.showData, false);
	local nowIdx = DataCenter.warOrderData.getCurWarOrderVo.show_cond;
	local advIdx = DataCenter.warOrderData:getAdvRewardIdx(self.showData);
	local isLock = DataCenter.warOrderData:curAdvActState(self.showData);
	local tvoArr;
	local tvo;
	if not isLock and advIdx <= nowIdx then
		for i = advIdx, nowIdx do
			tvoArr = rewardVoArr[i].advRewardVo;
			for j = 1, tvoArr:getSize() do
				tvo = tvoArr[j];
				if itemDic[tvo.id] == nil then
					itemDic[tvo.id] = tvo.count;
				else
					itemDic[tvo.id] = itemDic[tvo.id] + tvo.count;
				end
			end
		end
	end

	-- 直升等级得的奖励
	if isAddOther then
		endIdx = nowIdx + endIdx;
		endIdx = rewardVoArr:getSize() < endIdx and rewardVoArr:getSize() or endIdx;
		-- print(nowIdx + 1, endIdx);
		for i = nowIdx + 1, endIdx do
			tvoArr = rewardVoArr[i].norRewardVo;
			for j = 1, tvoArr:getSize() do
				tvo = tvoArr[j];
				if itemDic[tvo.id] == nil then
					itemDic[tvo.id] = tvo.count;
				else
					itemDic[tvo.id] = itemDic[tvo.id] + tvo.count;
				end
			end
	 
			tvoArr = rewardVoArr[i].advRewardVo;
			for j = 1, tvoArr:getSize() do
				tvo = tvoArr[j];
				if itemDic[tvo.id] == nil then
					itemDic[tvo.id] = tvo.count;
				else
					itemDic[tvo.id] = itemDic[tvo.id] + tvo.count;
				end
			end
		end
	end

	local arr = Array();
	for k, v in pairs(itemDic) do
		tvo = Lua_ToolVo.createToolVo(k, v);
		arr:add(tvo);
	end
	arr:sort("sortWeight", false);
	return arr;
end

function Lua_WarOrderBuyWindow:onBuyBtnClick()
	if self.rechargeInfo == nil then
		return;
	end
	DataCenter.sdkInterface:PointOut(1, tonumber(self.rechargeInfo.money), tonumber(self.rechargeInfo.money_type),
		tonumber(self.rechargeInfo.id), self.rechargeInfo.gift_name, self.rechargeInfo.gold);
	self:hide();
end

function Lua_WarOrderBuyWindow:dispose()
	if self.soonList ~= nil then
		self.soonList:dispose();
		self.soonList = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end










Lua_WarOrderBuyRewardItem = class("Lua_WarOrderBuyRewardItem", Lua_ListCell);
function Lua_WarOrderBuyRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_WarOrderBuyRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setScale(0.75, 0.75);
end

function Lua_WarOrderBuyRewardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end
	self.itemIcon:setData(data);
end

function Lua_WarOrderBuyRewardItem:onPressClick()
	if self._data == nil then
		return;
	end
	DataCenter.packUtil:showItemInfo(self._data);
end

function Lua_WarOrderBuyRewardItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end