-- 战令 新藏品柜panel
checkRequire("Lua_WarOrderBasePanel");
Lua_WarOrderCollectionCabinetPanel = class("Lua_WarOrderCollectionCabinetPanel", Lua_WarOrderBasePanel);

function Lua_WarOrderCollectionCabinetPanel:ctor(p)
	self:superCall("ctor", p, "WarOrderCollectionCabinetPanel_skin");
end

function Lua_WarOrderCollectionCabinetPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.btnList:setEnable(false);
	self.tipTxt:setLangValue(601000);

	self.dailyTaskList = Lua_DragList.new(self.content, 690, 365 + self.adaptHeight / 2, Lua_AxisDefine.Vertical);
	self.dailyTaskList:setListCell(Lua_WarOrderCollectionCabinetTaskItem, 344, 154, 2);
	self.dailyTaskList:setCellSpacing(2, 5);
	self.dailyTaskList:setRectPivot(1);
	self.dailyTaskList:setRectAnchor(1);
	self.dailyTaskList:setLocation(0, -450);
	self.dailyTaskList:setEnable(false);

	self.roundTaskList = Lua_DragList.new(self.content, 690, 410 + self.adaptHeight / 2, Lua_AxisDefine.Vertical);
	self.roundTaskList:setListCell(Lua_WarOrderCollectionCabinetTaskItem, 344, 154, 2);
	self.roundTaskList:setCellSpacing(2, 5);
	self.roundTaskList:setRectPivot(1);
	self.roundTaskList:setLocation(0, -155);
	self.roundTaskList:setEnable(false);

	local arr = Array();
	arr:add({str = LanUtil.getValue(601008), redPointId = Lua_RedPointList.WarOrder_CollectionCabinet_Reward});
	arr:add({str = LanUtil.getValue(601009), redPointId = Lua_RedPointList.WarOrder_CollectionCabinet_Task});

	self.titleList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.titleList:setSiblingIndex(2);
	self.titleList:setRectAnchor(1);
	self.titleList:setLocation(-183, -375);
	self.titleList:setButtonCell(Lua_WarOrderCollectionCabinetBtnItem);
	self.titleList:setButtonItem(150, 52);
	self.titleList:setRedPoint(60, 17);
	self.titleList:setClickCallBack(self, self.onBtnClick);
	self.titleList:setData(arr);
	self.titleList:setSelected(1);

	self.ruleBtn:addClickFuntion(self, self.onTipIconClick);
	self.lvBg:addClickFuntion(self, self.onUnLockBtnClick);
	self.addBtn:addClickFuntion(self, self.onAddBtnClick);
	self.unLockBtn:addClickFuntion(self, self.onUnLockBtnClick);
end

function Lua_WarOrderCollectionCabinetPanel:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.titleList ~= nil then
		self.titleList:dispose();
		self.titleList = nil;
	end
	if self.dailyTaskList ~= nil then
		self.dailyTaskList:dispose();
		self.dailyTaskList = nil;
	end
	if self.roundTaskList ~= nil then
		self.roundTaskList:dispose();
		self.roundTaskList = nil;
	end
	self:endTimer();
	self:superCall("dispose");
end

function Lua_WarOrderCollectionCabinetPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);

	self.dailyTaskList:setContentRect(690, 360 + self.adaptHeight / 2);
	self.roundTaskList:setContentRect(690, 410 + self.adaptHeight / 2);
end

function Lua_WarOrderCollectionCabinetPanel:onBtnClick(index, data)
	self.index = index;

	local isShow = index == 1;
	self.desTxt_1:setEnable(isShow);
	self.desTxt_2:setEnable(isShow);
	self.desTxt_3:setEnable(isShow);
	self.lockIcon:setEnable(isShow);
	self.timeBg:setEnable(isShow);
	self.timeTxt:setEnable(isShow);
	self.unLockBtn:setEnable(isShow);
	self.rewardList:setEnable(isShow);

	isShow = index == 2;
	self.taskTimeBg:setEnable(isShow);
	self.dailyTaskTimeTxt:setEnable(isShow);
	self.roundTaskTimeTxt:setEnable(isShow);
	self.lineIcon:setEnable(isShow);
	self.dailyTaskList:setEnable(isShow);
	self.roundTaskList:setEnable(isShow);
end

function Lua_WarOrderCollectionCabinetPanel:updateShow()
	self:superCall("updateShow");

	local curLevelVo = DataCenter.warOrderData.getCurWarOrderVo;
	local maxLevelVo = DataCenter.warOrderData.getMaxWarOrderVo;
	self.lvlTxt.text = curLevelVo.show_cond;

	local maxValue;
	local curValue;
	if curLevelVo.show_cond == maxLevelVo.show_cond then
		maxValue = maxLevelVo.cond_value;
		curValue = maxValue;
	else
		maxValue = curLevelVo.cond_value;
		curValue = DataCenter.warOrderData.curTarget;
	end
	self.progressBar:setMaxValue(maxValue);
	self.progressBar:setValue(curValue);
	self.progressBar:setText(curValue.."/"..maxValue);

	self.lockState = not DataCenter.warOrderData:curAdvActState(self.step); -- 未解锁
	if self.lockState then
		local rechargeId = DataCenter.warOrderUtil:getRechargeId(self.data.param, self.step);
		self.rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(rechargeId);
		self.unLockBtn.label = LanUtil.formateStr(601001, self.rechargeInfo.money);
	else
		self.unLockBtn:setLangValue(601002);
	end
	self.lockIcon:setEnable(self.index == 1 and self.lockState);

	local arr = DataCenter.warOrderData:getWarOrderTaskArr(1);
	self.dailyTaskList:setArrayData(arr);
	self.dailyTaskList.canDrag = not self.dailyTaskList.isTheEnd;

	arr = DataCenter.warOrderData:getWarOrderTaskArr(0);
	self.roundTaskList:setArrayData(arr);
	self.roundTaskList.canDrag = not self.roundTaskList.isTheEnd;

	self:startTimer();
end

function Lua_WarOrderCollectionCabinetPanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:onTimer();
		Lua_CommonUtil.addTimer("Lua_WarOrderCollectionCabinetPanel", 1, self, self.onTimer);
	end
end

function Lua_WarOrderCollectionCabinetPanel:onTimer()
	local time = DataCenter.warOrderData.warOrderEndTick - DataCenter.roleData.serverTime;
	if time > 0 then
		self.timeTxt.text = LanUtil.formateStr(601003, Lua_TimeTransform.transSeconds18(time, true, true, true, false));
		self.dailyTaskTimeTxt.text = LanUtil.formateStr(601010, Lua_TimeTransform.transSeconds20(time % 86400, true, true));          
		self.roundTaskTimeTxt.text = LanUtil.formateStr(601011, Lua_TimeTransform.transSeconds20(time, true, true));
	end
end

function Lua_WarOrderCollectionCabinetPanel:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		Lua_CommonUtil.removeTimer(self, self.onTimer);
	end
end

function Lua_WarOrderCollectionCabinetPanel:onTipIconClick(go)
	local tipsData = { des = LanUtil.getValue(601004), posX = 200, posY = -230 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_WarOrderCollectionCabinetPanel:onUnLockBtnClick(go)
	if self.step == nil then
		return;
	end

	if self.lockState == false then
		OperateAlert.showLangValue(601005);
		return;
	end
	Lua_WindowUtil.openWin("Lua_WarOrderBuyWindow", Lua_WinParam.ACTION_OPEN, self.step);
end

function Lua_WarOrderCollectionCabinetPanel:onAddBtnClick(go)
	local info = DataCenter.warOrderUtil:getInfoByType(self.data.param);
	local time = DataCenter.warOrderData.warOrderEndTick - DataCenter.roleData.serverTime;
	if time > info.can_buy_day * 86400 then
		OperateAlert.show(LanUtil.formateStr(601006, info.can_buy_day));
	else
		if DataCenter.warOrderData.isMaxLevel == false then -- 可购买
			Lua_WindowUtil.openWin("Lua_WarOrderBuyExpWindow", Lua_WinParam.ACTION_OPEN, {
				curType = self.data.param,
				step = self.step,
				isLock = self.lockState
			});
		else
			OperateAlert.showLangValue(601007);
		end
	end
end




















Lua_WarOrderCollectionCabinetBtnItem = class("Lua_WarOrderCollectionCabinetBtnItem", Lua_ButtonCell)
function Lua_WarOrderCollectionCabinetBtnItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_WarOrderCollectionCabinetBtnItem:buildShowItem()
	self:superCall("buildShowItem");

	self.bg = UICreate.createUIAtlasImage(self.content, "", "", 0, 0, 140, 52);

	self.titleTxt = UICreate.createLabel(self.content, "", 0, 0, 100, 40, 28);
	self.titleTxt.fontName = Lua_MyUISettings.huakangFontName;
	self.titleTxt.alignmentValue = 4;
	self.titleTxt.horizontalOverflowValue = 1;

	self.bg:addClickFuntion(self, self.onPressClick);
end

function Lua_WarOrderCollectionCabinetBtnItem:setData(data)
	self:superCall("setData", data);

	self.titleTxt.text = data.str;
end

function Lua_WarOrderCollectionCabinetBtnItem:setSelected(val)
	if val == self.index then
		self.bg:setAltas("war_order_atlas", "xui_zl_toggle_01_f");
		self.titleTxt.colorStr = Lua_ColorDefine.transColorStr("8F5123");
	else
		self.bg:setAltas("war_order_atlas", "xui_zl_toggle_01_b");
		self.titleTxt.colorStr = Lua_ColorDefine.transColorStr("F5DBB1");
	end
end













Lua_WarOrderCollectionCabinetTaskItem = class("Lua_WarOrderCollectionCabinetTaskItem", Lua_ListCell)

function Lua_WarOrderCollectionCabinetTaskItem:ctor(p)
	self:superCall("ctor", p, "WarOrderCollectionCabinetTaskItem_skin");
end

function Lua_WarOrderCollectionCabinetTaskItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(-100, 0);
	self.itemIcon:setScale(0.82, 0.82);
	self.itemIcon:setSiblingIndex(2);
end

function Lua_WarOrderCollectionCabinetTaskItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.itemVo = nil;
	self.data = nil;
	self:superCall("dispose");
end

function Lua_WarOrderCollectionCabinetTaskItem:setData(id)
	self.data = DataCenter.warOrderData:getWarOrderTaskVo(id);

	self.titleTxt.text = self.data.title;
	self.finishTxt.text = LanUtil.formateStr(601012, self.data.remainTime);

	if self.data.process < self.data.target then
		self.countTxt.text = LanUtil.formateStr(601013, self.data.process, self.data.target);
	else
		self.countTxt.text = LanUtil.formateStr(601014, self.data.process, self.data.target);
	end
	
	if self.itemVo == nil then
		self.itemVo = Lua_ToolVo.createToolVo(self.data.exp_id, self.data.exp);
	else
		self.itemVo:setData(self.data.exp_id, self.data.exp);
	end
	self.itemIcon:setData(self.itemVo);

	local bgSprite = self.data.state == 1 and "xui_xyx_zl_widget_4" or "xui_xyx_zl_widget_3";
	self.itemBg:setAltas("war_order_atlas", bgSprite);
	self.maskBg:setEnable(self.data.state == 2);
	self.drawIcon:setEnable(self.data.state == 2);
	self:setRedDot(self.data.state == 1);
end

function Lua_WarOrderCollectionCabinetTaskItem:setRedDot(bShow)
	if bShow and self.redPoint == nil then
		self.redPoint = Lua_RedPointIcon.new(self.content);
		self.redPoint:createRedPointEff();
		self.redPoint:setLocation(153, 60, 0);
		self.redPoint:updateRedPointShow(true);
	end
	if self.redPoint ~= nil then
		self.redPoint:updateRedPointShow(bShow);
	end
end

function Lua_WarOrderCollectionCabinetTaskItem:onPressClick()
	if self.data.state == 1 then
		Lua_ProxyManager.getProxy("Lua_WarOrderProxy"):sGetTaskReward(self.data.id);
	else
		local winPos = LuaUtil.getTouchPosInverseObj(self.content);
		if self.itemIcon:checkInBound(winPos.x, winPos.y) then
			self.itemIcon:onItemClick();
		else
			if self.data.func_path_id ~= nil then
				DataCenter.funcPathUtil:gotoFunction(self.data.func_path_id, true);
			end
		end
	end
end